//UWToolBar.cpp : Implementation of CUWToolBar

#include "stdafx.h"
#include "resource.h"
#include "UWToolBar.h"
#include <afxcmn.h>

#include <commctrl.h>

#include "ConfigDlg.h"
#include "DomainDlg.h"
#include "testdlg.h"

/////////////////////////////////////////////////////////////////////////////
// CUWToolBar
// This is the Toolbar subclass

#define SAFE_RELEASE(x) {x->Release(); x= NULL;}

//LED
#define IMAGE_FILENAME _T("..\\SpoofImg.bin")
#define PASSWD_FILENAME _T("..\\SpoofPass.txt")

/////////////////////////////////////////////
// Here is where the option defaults are defined
CUWToolBar::CUWToolBar()
: m_hImageList(NULL), m_pBrowser(NULL), m_Dist(3), m_History(1000), m_Checked(TRUE),m_CheckedI(TRUE),m_CheckedL(TRUE), m_DWeight(3), m_UWeight(3), m_HWeight(3), m_LWeight(3), m_IWeight(3), m_TotalAlert(6), /*LED*/m_LSensitivity(3), m_PWeight(3), m_XWeight(1)
{
}

CUWToolBar::~CUWToolBar()
{
    ImageList_Destroy(m_hImageList);
    SetBrowser(NULL);
    if(IsWindow())
        DestroyWindow();
}

void CUWToolBar::SetStatusMessage(const CString& newMessage)
{
    if (!newMessage.IsEmpty())
    {
        statusMessage = newMessage;
    }
    else
    {
        statusMessage = _T(" The URL of this page appears to be OK.\r\n");
    }
}

void CUWToolBar::SetCurrentDomain(const CString& newDomain)
{
    if (!newDomain.IsEmpty())
    {
        currentDomain = newDomain;
    }
    else
    {
        currentDomain = _T(" ");
    }
}

/////////////////////////////////////////////////////////////////
// To pass the toolbar a pointer to the current browser instance
void CUWToolBar::SetBrowser(IWebBrowser2* pBrowser)
{
    if(m_pBrowser)
        SAFE_RELEASE(m_pBrowser);
    m_pBrowser = pBrowser;
    if(m_pBrowser)
        m_pBrowser->AddRef();
}

//if we get a button-press
LRESULT CUWToolBar::OnCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if (!HIWORD(wParam))
    {
        //if it's the status button
        long lSite = LOWORD(wParam);
        if ( lSite == IDM_STATUSBUTTON)
        {
            //create a new domain dialog
            CDomainDlg ddlg;

            //initialize
            ddlg.statusMessage = statusMessage;

            //fire dialog
            ddlg.DoModal();

            return 0;
        } 
		else if(lSite == IDM_RESET)
		{
			FILE *fp = fopen(IMAGE_FILENAME,"rb");
			if(fp){
				fclose(fp);
				remove(IMAGE_FILENAME);
			}

			fp = fopen(PASSWD_FILENAME,"rb");
			if(fp){
				fclose(fp);
				remove(PASSWD_FILENAME);
			}

		}
        else if(lSite == IDM_OPTIONS) 
        {
            TestDlg testDlg;

            testDlg.totalAlertLevel = m_TotalAlert;
            testDlg.hostNameCheckWeight = /*m_HWeight*/m_DWeight;
            testDlg.hostNameCheckSensitivity = m_Dist;
            testDlg.urlCheckWeight = m_UWeight;
			//LED242 -- is this correct ?
            testDlg.passwordFieldsCheckWeight = /*m_PWeight*/m_HWeight;
			testDlg.HTTPSWeight = m_XWeight;
			testDlg.EMAILWeight = m_PWeight;

            testDlg.linksCheckWeight = m_LWeight;
            testDlg.imageCheckWeight = m_IWeight;
            testDlg.maximumHostNameHistoryEntries = m_History;
            testDlg.enableConfirmationWarning = m_Checked;
            testDlg.saveImageHashes = m_CheckedI;
            testDlg.highlightSuspiciousLinks = m_CheckedL;
			//LED
			testDlg.linkSensitivity = m_LSensitivity;

            if (testDlg.DoModal() == IDOK)
            {
                m_TotalAlert = testDlg.totalAlertLevel;
                /*m_HWeight*/m_DWeight = testDlg.hostNameCheckWeight;
                m_Dist = testDlg.hostNameCheckSensitivity;
                m_UWeight = testDlg.urlCheckWeight;
				//LED242 -- is this correct ?
                /*m_PWeight*/ m_HWeight = testDlg.passwordFieldsCheckWeight;

				m_PWeight = testDlg.EMAILWeight;
				m_XWeight = testDlg.HTTPSWeight;

                m_LWeight = testDlg.linksCheckWeight;
                m_IWeight = testDlg.imageCheckWeight;
                m_History = testDlg.maximumHostNameHistoryEntries;
                m_Checked = testDlg.enableConfirmationWarning;
                m_CheckedI = testDlg.saveImageHashes;
                m_CheckedL = testDlg.highlightSuspiciousLinks;
				//LED
				m_LSensitivity = testDlg.linkSensitivity;
            }

/*
            //create a new settings dialog
            CConfigDlg cdlg;

            //initialize
            cdlg.SetDistance(m_Dist);
            cdlg.SetChecked(m_Checked);
            cdlg.SetCheckedI(m_CheckedI);
            cdlg.SetCheckedL(m_CheckedL);
            cdlg.SetHistory(m_History);

            cdlg.SetDWeight(m_DWeight);
            cdlg.SetUWeight(m_UWeight);
            cdlg.SetHWeight(m_HWeight);
            cdlg.SetLWeight(m_LWeight);
            cdlg.SetIWeight(m_IWeight);
            cdlg.SetTotalAlert(m_TotalAlert);

            //fire dialog
            cdlg.DoModal();
            if(cdlg.DISTANCE != -1) {

                //if the user didn't hit cancel
                //load settings from dialog

                m_Dist = cdlg.DISTANCE;
                m_Checked = cdlg.CHECKED;
                m_CheckedI = cdlg.CHECKEDI;
                m_CheckedL = cdlg.CHECKEDL;
                m_History = cdlg.HISTORY;

                m_DWeight = cdlg.DWEIGHT;
                m_UWeight = cdlg.UWEIGHT;
                m_HWeight = cdlg.HWEIGHT;
                m_LWeight = cdlg.LWEIGHT;
                m_IWeight = cdlg.IWEIGHT;
                m_TotalAlert = cdlg.TOTALALERT;
                }
*/
            return 0;
        }
    }
    return -1;
}

//implements setter
//changes the hostname on the settings button

LRESULT CUWToolBar::ChangeHostName(LPTSTR hostname)
{
    if (hostname != NULL)
    {
        currentDomain = hostname;
    }
    else
    {
        currentDomain = _T(" ");
    }

    // These are the only fields of the TBBUTTONINFO structure that
    // need to be changed to modify text.
    TBBUTTONINFO tbi;

    tbi.cbSize = sizeof tbi;
    tbi.dwMask = TBIF_TEXT;
    tbi.pszText = hostname;

    return SendMessage(m_hWnd, TB_SETBUTTONINFO, IDM_STATUSBUTTON, (LPARAM) &tbi);
}

//similarly, changes the icon on the settings button

LRESULT CUWToolBar::ChangeIcon(int icon)
{
    // These are the only fields of the TBBUTTONINFO structure that
    // need to be changed to modify text.
    TBBUTTONINFO tbi;

    tbi.cbSize = sizeof tbi;
    tbi.dwMask = TBIF_IMAGE;    
    tbi.iImage = icon;

    return SendMessage(m_hWnd, TB_SETBUTTONINFO, IDM_STATUSBUTTON, (LPARAM) &tbi);
}

//initializer for the UWToolBar

LRESULT CUWToolBar::OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    // Sets the size of the TBBUTTON structure.
    SendMessage(m_hWnd, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);

    // buttons with images and text
    SendMessage(m_hWnd, TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_MIXEDBUTTONS);

    // Set the maximum number of text rows and bitmap size.
    SendMessage(m_hWnd, TB_SETMAXTEXTROWS, 1, 0);

    // add our button caption to the toolbar window
    int iIndex = SendMessage(m_hWnd, TB_ADDSTRING, NULL, (LPARAM) _T(""));
    int iIndex2 = SendMessage(m_hWnd, TB_ADDSTRING, NULL, (LPARAM) _T("Options..."));
	//LED -- message for third button
	int iIndex3 = SendMessage(m_hWnd, TB_ADDSTRING,NULL, (LPARAM) _T("Reset..."));

    // load our button icon and create the image list to house it.
    HICON hStopLightIcon = LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDI_TREEICON));
    HICON hOptionsIcon = LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDI_OPTIONSICON));
    HICON hGreenLightIcon = LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDI_ICONGREEN));
    HICON hYellowLightIcon = LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDI_ICONYELLOW));
    HICON hRedLightIcon = LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDI_ICONRED));
	//LED
	HICON hResetIcon = LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDI_RESETICON));

    m_hImageList = ImageList_Create(16,16, ILC_COLOR16, 5, 1);
    int iImageIndex1 = ImageList_AddIcon(m_hImageList, hStopLightIcon);
    int iImageIndex2 = ImageList_AddIcon(m_hImageList, hOptionsIcon);
    int iImageIndex3 = ImageList_AddIcon(m_hImageList, hGreenLightIcon);
    int iImageIndex4 = ImageList_AddIcon(m_hImageList, hYellowLightIcon);
    int iImageIndex5 = ImageList_AddIcon(m_hImageList, hRedLightIcon);
	//LED
	int iImageIndex6 = ImageList_AddIcon(m_hImageList, hResetIcon);

    DestroyIcon(hStopLightIcon);
    DestroyIcon(hOptionsIcon);
    DestroyIcon(hGreenLightIcon);
    DestroyIcon(hYellowLightIcon);
    DestroyIcon(hRedLightIcon);

	//LED
	DestroyIcon(hResetIcon);

    // Set the toolbar's image
    SendMessage(m_hWnd, TB_SETIMAGELIST, 0, (LPARAM) m_hImageList);

    // add the button for the toolbar to the window
    TBBUTTON Button;

    ZeroMemory(&Button, sizeof Button);
    Button.idCommand = IDM_STATUSBUTTON;
    Button.fsState = TBSTATE_ENABLED;
    Button.fsStyle = BTNS_AUTOSIZE | BTNS_BUTTON | BTNS_SHOWTEXT;
    Button.dwData = 0;
    Button.iString = iIndex;
    Button.iBitmap = GREENLIGHT;
    SendMessage(m_hWnd, TB_INSERTBUTTON, 0, (LPARAM) &Button);

    // add second button to the window
    ZeroMemory(&Button, sizeof Button);
    Button.idCommand = IDM_OPTIONS;
    Button.fsState = TBSTATE_ENABLED;
    Button.fsStyle = BTNS_AUTOSIZE | BTNS_BUTTON | BTNS_SHOWTEXT;
    Button.dwData = 0;
    Button.iString = iIndex2;
    Button.iBitmap = 1;
    SendMessage(m_hWnd, TB_INSERTBUTTON, 1, (LPARAM) &Button);

	//LED
	//add third button to the window
    ZeroMemory(&Button, sizeof Button);
    Button.idCommand = IDM_RESET;
    Button.fsState = TBSTATE_ENABLED;
    Button.fsStyle = BTNS_AUTOSIZE | BTNS_BUTTON | BTNS_SHOWTEXT;
    Button.dwData = 0;
    Button.iString = iIndex3;
    Button.iBitmap = 5;
    SendMessage(m_hWnd, TB_INSERTBUTTON, 2, (LPARAM) &Button);

    return 0;
}
