// WarnBar.cpp - Implementation of CWarnBar.

#include "stdafx.h"
#include "URLWarning.h"
#include "WarnBar.h"
#include <windows.h>
#include <wincrypt.h>
#include <wininet.h>
#include <wchar.h>
#include <winsock2.h>
//#include "Shlwapi.h"
//#include "FlexLexer.h"
#include "scanner.h"
#include "SHA1.h"

/*
#include <comdef.h>
#include <iostream>
#include "ansmtp.tlh"
using namespace ANSMTPLib;
using namespace std;
*/

#include "smtp.h"
#include <afxsock.h>



const WCHAR TITLE_CWarnBar[] = L"SpoofGuard"; // Toolbar Title

//IUnknown* globalpUnkSite;

//this seems to have caused A LOT of bugs
//when i started using the documentcomplete handler

//this has been moved to WarnBar.h
//so that there is one for each instance of the class


/////////////////////////////////////////////////////////////////////////////
// CWarnBar

CWarnBar::CWarnBar():

//initialize values

m_dwBandID(0),
m_dwViewMode(0),
m_bShow(FALSE),
m_bEnterHelpMode(FALSE),
m_hWndParent(NULL),
m_pSite(NULL),
m_pHistory(NULL),
m_pHistoryList(NULL),
m_LoadedFromReg(FALSE),

//  globalpUnkSite(NULL),

alreadyWarned(0),
//beforeNaved(0),
//preSum(0),
//postSum(0),
outerFrameIsInHistory(0),
repeatedImageFound(0),
badLinkFound(0),
encryptedSite(0),
isForm(0),

registered(0),
//framesInHistory(1),
cancelledNavigation(0),
inputFieldsFound(0),
m_webBrowser(NULL)
{
    m_ReflectionWnd.GetToolBar(); // .GetEditBox().SetBand(this);
}

//helper function
//this is called from setsite, where we initialize, if we're passed a non-null pUnkSite

BOOL CWarnBar::RegisterAndCreateWindow()
{
    //register window
    RECT rect;
    GetClientRect(m_hWndParent, &rect);
    
    //create instance of ReflectionWnd, which creates a UWToolbar
    m_ReflectionWnd.Create(m_hWndParent, rect, NULL, WS_CHILD);

    LoadRegVals();  // Load saved settings from registry

    //pass loaded values to UWToolbar
    if(m_LoadedFromReg)
    {
        m_ReflectionWnd.GetToolBar().SetCheckedValue(m_RegWarn);
        m_ReflectionWnd.GetToolBar().SetCheckedIValue(m_RegWarnI);
        m_ReflectionWnd.GetToolBar().SetCheckedLValue(m_RegWarnL);
        m_ReflectionWnd.GetToolBar().SetDistValue(m_RegDist);
        m_ReflectionWnd.GetToolBar().SetHistValue(m_RegHist);

        m_ReflectionWnd.GetToolBar().SetDWeightValue(m_RegDWeight);
        m_ReflectionWnd.GetToolBar().SetUWeightValue(m_RegUWeight);
        m_ReflectionWnd.GetToolBar().SetHWeightValue(m_RegHWeight);
        m_ReflectionWnd.GetToolBar().SetLWeightValue(m_RegLWeight);
        m_ReflectionWnd.GetToolBar().SetIWeightValue(m_RegIWeight);
        m_ReflectionWnd.GetToolBar().SetTotalAlertValue(m_RegTotalAlert);

		//LED
		m_ReflectionWnd.GetToolBar().SetLSensitivityValue(m_RegLSensitivity);
		m_ReflectionWnd.GetToolBar().SetPWeightValue(m_RegPWeight);
		m_ReflectionWnd.GetToolBar().SetXWeightValue(m_RegXWeight);

    }

    //only successful if the UWToolbar worked
    return m_ReflectionWnd.GetToolBar().IsWindow();
}

// implemented for IDeskBand
// just sets some display info for the toolbar
STDMETHODIMP CWarnBar::GetBandInfo(DWORD dwBandID, DWORD dwViewMode, DESKBANDINFO* pdbi)
{
    m_dwBandID = dwBandID;
    m_dwViewMode = dwViewMode;

    if (pdbi->dwMask & DBIM_MINSIZE)
    {
        pdbi->ptMinSize.x = 275;
        pdbi->ptMinSize.y = 22;
    }
    if (pdbi->dwMask & DBIM_MAXSIZE)
    {
        pdbi->ptMaxSize.x = 0; // ignored
        pdbi->ptMaxSize.y = -1; // no maximum height limit
    }
    if (pdbi->dwMask & DBIM_ACTUAL)
    {
        pdbi->ptActual.x = 250;
        pdbi->ptActual.y = 22;
    }


    if (pdbi->dwMask & DBIM_TITLE)
    {
        wcscpy(pdbi->wszTitle, TITLE_CWarnBar);
    }
    if (pdbi->dwMask & DBIM_MODEFLAGS)
    {
        pdbi->dwModeFlags = DBIMF_NORMAL;
    }

	if (pdbi->dwMask & DBIM_BKCOLOR){
		
		
		pdbi->dwMask &= ~DBIM_BKCOLOR;
		pdbi->crBkgnd = RGB(255,0,0);
		pdbi->crBkgnd = 0x7CFC00;
		

	}


    return S_OK;
}

// implemented for IOleWindow
// just a getter for our window, UWToolBar
STDMETHODIMP CWarnBar::GetWindow(HWND* phwnd)
{
    if (phwnd == NULL)
    {
        return E_INVALIDARG;
    }

    *phwnd = m_ReflectionWnd.GetToolBar().m_hWnd;
    return S_OK;
}

// implemented for IOleWindow
STDMETHODIMP CWarnBar::ContextSensitiveHelp(BOOL fEnterMode)
{
    m_bEnterHelpMode = fEnterMode;
    return S_OK;
}

// implemented for IDockingWindow
STDMETHODIMP CWarnBar::CloseDW(DWORD dwReserved)
{
    ShowDW(FALSE);
    return S_OK;
}

// implemented for IDockingWindow
STDMETHODIMP CWarnBar::ResizeBorderDW(LPCRECT prcBorder, IUnknown *punkToolbarSite, BOOL fReserved)
{
    // Not used by any band object.
    return E_NOTIMPL;
}

// implemented for IDockingWindow
STDMETHODIMP CWarnBar::ShowDW(BOOL fShow)
{
    m_bShow = fShow;
    m_ReflectionWnd.GetToolBar().ShowWindow(m_bShow ? SW_SHOW : SW_HIDE);
    return S_OK;
}

// implemented for IObjectWithSite
// This method sets up the site, passes the webbrowser object to the toolbar,
// and registers the event sink.
// This is called once (non-null) when a new window opens
// and again (null) when it is closed
STDMETHODIMP CWarnBar::SetSite(IUnknown* pUnkSite)
{
    //IUnknown *random = pUnkSite;

    //save the webbrowser object
    //if we're holding on to a site, release it
    if (m_pSite != NULL)
    {
        //m_ReflectionWnd.GetToolBar().SetBrowser(NULL); // We set this to NULL when we unadvise.
        SAFE_RELEASE(m_pSite);
    }

    // If punkSite is not NULL, a new site is being set.
    // This is initialization
    if (pUnkSite != NULL)
    {
        //Get the parent window.
        IOleWindow *pOleWindow = NULL;
        m_hWndParent = NULL;

        if (SUCCEEDED(pUnkSite->QueryInterface(IID_IOleWindow, (void **) &pOleWindow)))
        {
            pOleWindow->GetWindow(&m_hWndParent);
            SAFE_RELEASE(pOleWindow);
        }

        if (!::IsWindow(m_hWndParent))
        {
            return E_FAIL;
        }

        if (!RegisterAndCreateWindow())
        {
            return E_FAIL;
        }

        if (FAILED(pUnkSite->QueryInterface(IID_IInputObjectSite, (void **) &m_pSite)))
        {
            return E_FAIL;
        }

        // Allocate the History List and its Lock
        // ---------------------------------------
        if (!(m_pHistoryList = new CStringList()))
        {
            return E_FAIL;
        }

        // Get the History object
        // ----------------------
        //CoInitialize(NULL);
        HRESULT hr = CoCreateInstance(CLSID_CUrlHistory, NULL, CLSCTX_INPROC_SERVER, IID_IUrlHistoryStg2,
            reinterpret_cast<void**>(&m_pHistory));
        if (SUCCEEDED(hr))
        {
            // IE History interface is at our disposal
            //helper function:
            //goes through our history and copies all the domain names to a list
            //as new pages are visited, we add them to our list ourselves
            //to sync up with history
            EnumerateHistory();
        }
        else
        {
            m_pHistory = NULL;
            return E_FAIL;
        }

        // Get the webbrowser object
        // -------------------------
        IWebBrowser2* s_pFrameWB = NULL;
        IOleCommandTarget* pCmdTarget = NULL;
        hr = pUnkSite->QueryInterface(IID_IOleCommandTarget, (void **) &pCmdTarget);
        if (SUCCEEDED(hr))
        {
            IServiceProvider *pSP;
            hr = pCmdTarget->QueryInterface(IID_IServiceProvider, (void **) &pSP);

            SAFE_RELEASE(pCmdTarget);

            if (SUCCEEDED(hr))
            {
                hr = pSP->QueryService(SID_SWebBrowserApp, IID_IWebBrowser2, (LPVOID*)&s_pFrameWB);
                SAFE_RELEASE(pSP);
                //_ASSERT(s_pFrameWB);
                if (!s_pFrameWB)
                {
                    return S_OK;
                }

                m_webBrowser = s_pFrameWB;
                m_ReflectionWnd.GetToolBar().SetBrowser(s_pFrameWB);

                // Set up the event sink before releasing browser object
                CComQIPtr<IServiceProvider> spSP(pUnkSite);
                if (spSP)
                {
                    spSP->QueryService(__uuidof(/*&SHDocVw::*/IWebBrowserApp),
                        __uuidof(/*SHDocVw::*/IWebBrowser2),
                        (void**)&s_pFrameWB);
                    theDispEvent::DispEventAdvise(s_pFrameWB);
                }
                SAFE_RELEASE(s_pFrameWB);
            }
        }

        registered = 1;
    }
    else
    {
        // pUnkSite is NULL. we're being closed
        // Release browser interface and history before quitting
        IWebBrowser2* pWB = m_ReflectionWnd.GetToolBar().GetBrowser();
        if (pWB)
        {
            // First save the current settings to the registry
            SaveRegVals();
            theDispEvent::DispEventUnadvise(pWB);
            m_ReflectionWnd.GetToolBar().SetBrowser(NULL);

            // Free the historyList
            if (m_pHistoryList)
            {
                delete m_pHistoryList;
            }

            // Also release the history
            if (m_pHistory)
            {
                SAFE_RELEASE(m_pHistory);
                //CoUninitialize();
            }
        }
    }

    //if(pUnkSite)SAFE_RELEASE(pUnkSite);
    return S_OK;
}

// called at init
// load user settings from registry into globals
// after this, they'll be passed to UWToolBar
// set m_loadedfromreg if succeeded
void CWarnBar::LoadRegVals()
{
    m_LoadedFromReg = FALSE;

    HKEY hKey = NULL;
    LONG res = RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\URLGuard"), 0, KEY_READ, &hKey);

    if (res == ERROR_SUCCESS)
    {
        DWORD type;
        DWORD data;
        DWORD size = sizeof(DWORD);

        // All of our data is DWORD size
        res = RegQueryValueEx(hKey, _T("Hist"), NULL, &type, (BYTE*)(&data), &size);

        if (res == ERROR_SUCCESS)
        {
            m_RegHist = data;

            res = RegQueryValueEx(hKey, _T("Dist"), NULL, &type, (BYTE*)(&data), &size);
            if(res == ERROR_SUCCESS)
            {
                m_RegDist = data;

                res = RegQueryValueEx(hKey, _T("Warn"), NULL, &type, (BYTE*)(&data), &size);
                if(res == ERROR_SUCCESS) {
                    m_RegWarn = data;

                    //-----
                    res = RegQueryValueEx(hKey, _T("WarnI"), NULL, &type, (BYTE*)(&data), &size);
                    if(res == ERROR_SUCCESS) {
                        m_RegWarnI = data;

                        res = RegQueryValueEx(hKey, _T("WarnL"), NULL, &type, (BYTE*)(&data), &size);
                        if(res == ERROR_SUCCESS) {
                            m_RegWarnL = data;

                            res = RegQueryValueEx(hKey, _T("DWeight"), NULL, &type, (BYTE*)(&data), &size);
                            if(res == ERROR_SUCCESS) {
                                m_RegDWeight = data;

                                res = RegQueryValueEx(hKey, _T("UWeight"), NULL, &type, (BYTE*)(&data), &size);
                                if(res == ERROR_SUCCESS) {
                                    m_RegUWeight = data;

                                    res = RegQueryValueEx(hKey, _T("HWeight"), NULL, &type, (BYTE*)(&data), &size);
                                    if(res == ERROR_SUCCESS) {
                                        m_RegHWeight = data;

                                        res = RegQueryValueEx(hKey, _T("LWeight"), NULL, &type, (BYTE*)(&data), &size);
                                        if(res == ERROR_SUCCESS) {
                                            m_RegLWeight = data;

                                            res = RegQueryValueEx(hKey, _T("IWeight"), NULL, &type, (BYTE*)(&data), &size);
                                            if(res == ERROR_SUCCESS) {
                                                m_RegIWeight = data;

                                                res = RegQueryValueEx(hKey, _T("TotalAlert"), NULL, &type, (BYTE*)(&data), &size);
                                                if(res == ERROR_SUCCESS) {
                                                    m_RegTotalAlert = data;
													
													//LED242
													res = RegQueryValueEx(hKey, _T("LSensitivity"), NULL, &type, (BYTE*)(&data), &size);
													if(res == ERROR_SUCCESS) {
														m_RegLSensitivity = data;

														res = RegQueryValueEx(hKey, _T("PWeight"), NULL, &type, (BYTE*)(&data), &size);
														if(res == ERROR_SUCCESS) {
															m_RegPWeight = data;

															res = RegQueryValueEx(hKey, _T("XWeight"), NULL, &type, (BYTE*)(&data), &size);
															if(res == ERROR_SUCCESS) {
																m_RegXWeight = data;

																m_LoadedFromReg = TRUE;
															}

														}
													}
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        RegCloseKey(hKey);
    }
}

// Similarly,
// save values from UWToolBar and save them into registry

void CWarnBar::SaveRegVals() {
    TRACE("Saving Settings from Registry...\n");
    BOOL saved = FALSE;

    HKEY hKey = NULL;
    LONG res = RegCreateKeyEx(HKEY_CURRENT_USER, _T("Software\\URLGuard"), 0, NULL, REG_OPTION_NON_VOLATILE,
        KEY_WRITE, NULL, &hKey, NULL);
    if(res == ERROR_SUCCESS) {
        DWORD data;
        DWORD size = sizeof(DWORD);

        data = m_ReflectionWnd.GetToolBar().GetHistValue();
        res = RegSetValueEx(hKey, "Hist", 0, REG_DWORD, (BYTE*)(&data), size);
        if(res == ERROR_SUCCESS) {

            data = m_ReflectionWnd.GetToolBar().GetDistValue();
            res = RegSetValueEx(hKey, "Dist", 0, REG_DWORD, (BYTE*)(&data), size);
            if(res == ERROR_SUCCESS) {

                data = m_ReflectionWnd.GetToolBar().GetCheckedValue();
                res = RegSetValueEx(hKey, "Warn", 0, REG_DWORD, (BYTE*)(&data), size);
                if(res == ERROR_SUCCESS) {

                    //--------------

                    data = m_ReflectionWnd.GetToolBar().GetCheckedIValue();
                    res = RegSetValueEx(hKey, "WarnI", 0, REG_DWORD, (BYTE*)(&data), size);
                    if(res == ERROR_SUCCESS) {

                        data = m_ReflectionWnd.GetToolBar().GetCheckedLValue();
                        res = RegSetValueEx(hKey, "WarnL", 0, REG_DWORD, (BYTE*)(&data), size);
                        if(res == ERROR_SUCCESS) {

                            data = m_ReflectionWnd.GetToolBar().GetDWeightValue();
                            res = RegSetValueEx(hKey, "DWeight", 0, REG_DWORD, (BYTE*)(&data), size);
                            if(res == ERROR_SUCCESS) {

                                data = m_ReflectionWnd.GetToolBar().GetUWeightValue();
                                res = RegSetValueEx(hKey, "UWeight", 0, REG_DWORD, (BYTE*)(&data), size);
                                if(res == ERROR_SUCCESS) {

                                    data = m_ReflectionWnd.GetToolBar().GetHWeightValue();
                                    res = RegSetValueEx(hKey, "HWeight", 0, REG_DWORD, (BYTE*)(&data), size);
                                    if(res == ERROR_SUCCESS) {

                                        data = m_ReflectionWnd.GetToolBar().GetLWeightValue();
                                        res = RegSetValueEx(hKey, "LWeight", 0, REG_DWORD, (BYTE*)(&data), size);
                                        if(res == ERROR_SUCCESS) {

                                            data = m_ReflectionWnd.GetToolBar().GetIWeightValue();
                                            res = RegSetValueEx(hKey, "IWeight", 0, REG_DWORD, (BYTE*)(&data), size);
                                            if(res == ERROR_SUCCESS) {

                                                data = m_ReflectionWnd.GetToolBar().GetTotalAlertValue();
                                                res = RegSetValueEx(hKey, "TotalAlert", 0, REG_DWORD, (BYTE*)(&data), size);
                                                if(res == ERROR_SUCCESS) {

													//LED
													data = m_ReflectionWnd.GetToolBar().GetLSensitivityValue();
													res = RegSetValueEx(hKey, "LSensitivity", 0, REG_DWORD, (BYTE*)(&data), size);
													if(res == ERROR_SUCCESS) {
														
														data = m_ReflectionWnd.GetToolBar().GetPWeightValue();
														res = RegSetValueEx(hKey, "PWeight", 0, REG_DWORD, (BYTE*)(&data), size);
														if(res == ERROR_SUCCESS) {

															data = m_ReflectionWnd.GetToolBar().GetXWeightValue();
															res = RegSetValueEx(hKey, "XWeight", 0, REG_DWORD, (BYTE*)(&data), size);
															if(res == ERROR_SUCCESS) {

																saved = TRUE;
															}
														}
													}
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        //RegFlushKey
        RegCloseKey(hKey);
    }

    TRACE("Saved to Reg = %d\n", saved);
}



// DBrowserEvents2::DocumentComplete
// This is called every time a navigation completes.
// from here, we have all the information about the page
// so this is where we do our second round checks

HRESULT _stdcall CWarnBar::DocumentComplete(IDispatch* pDisp, VARIANT* URL)
{

    //m_ReflectionWnd.MessageBox(_T("Document Complete Started"), _T("Document Complete"), 0);

    //return if not visible

     if(!m_bShow) {

        return S_OK;
    }

    //return if not initialized

    if(!registered){

        return S_OK;
    }

    //return if the user cancelled navigation
    //and this is just reloading of the last page

    if(cancelledNavigation)
    {
        return S_OK;
    }

//LED222
//if(0)
{

    //where we store the value of our checks

    repeatedImageFound = badLinkFound = inputFieldsFound = encryptedSite = 0;


    //set isForm to 0 before parsing the HTML to
    //find out if there is a form in the site
    isForm = 0;


/*
	{

				_bstr_t url;
		try {
			url = _bstr_t(URL);
		}
		catch(_com_error ce) {
			TRACE("BEFORENAVIGATE2: Caught _bstr_t conversion error: %s\n", ce.ErrorMessage());
		}


		const int MAX_URL_LEN = 2100;
		TCHAR szCanonBuff[MAX_URL_LEN];
		DWORD buffLen = MAX_URL_LEN;



		URL_COMPONENTS urlComps;
		TCHAR szHost[MAX_URL_LEN];
		TCHAR szPath[MAX_URL_LEN];
		TCHAR szExtraInfo[MAX_URL_LEN];
		TCHAR szUserName[MAX_URL_LEN];

		memset(&urlComps, 0, sizeof(urlComps));
		urlComps.dwStructSize = sizeof(urlComps);
		urlComps.lpszHostName = szHost;
		urlComps.dwHostNameLength = MAX_URL_LEN;
		urlComps.lpszUrlPath = szPath;
		urlComps.dwUrlPathLength = MAX_URL_LEN;
		urlComps.lpszUserName = szUserName;
		urlComps.dwUserNameLength = MAX_URL_LEN;
		urlComps.lpszExtraInfo = szExtraInfo;
		urlComps.dwExtraInfoLength = MAX_URL_LEN;



		int can = InternetCanonicalizeUrl((const char *)url, szCanonBuff, &buffLen, 0);
		int crack = InternetCrackUrl(szCanonBuff, buffLen, 0, &urlComps);



		{
			CString tmp;
			tmp.Format("DOCUMENT COMPLETE: (%s)  -- pdisp: %d -- url: %d -- canon: %d -- crack: %d -- crackedhostname: %s", szCanonBuff,pDisp, URL,can,crack,urlComps.lpszHostName);
			
			//m_ReflectionWnd.MessageBox(tmp, _T("SpoofGuard"), 0);
		}

	}
*/


/*
	//LED244
    //IHTMLDocument2 *doc;
    //int goodDoc = GetDocument(pDisp,&doc);	

	
	//always do an image check
    //to update for new images at frequently-visited domains
    //store result in repeatedImageFound

	//LED244
	//repeatedImageFound = ImageCheck(doc,URL);

	//LED244
	//if(outerFrameIsInHistory){
	//	m_ReflectionWnd.MessageBox(_T("DOCUMENT COMPLETE - beginning and end - already in history"), _T("SpoofGuard"), 0);
	//	return S_OK;
	//}
*/	


	//if the web browser interface fails,
	//we'll assume we're in the outer frame

	//check if we're in the outer frame.
	//we don't want to do much if we're in an inner frame.




	int rett = 0;
	
	int isPossiblyOuterFrame = 0;
	int isDefinatelyOuterFrame = 0;
//    int redirected = 1;

	//IUnknown*  pUnk;
	LPDISPATCH lpWBDisp;
	HRESULT    hr;
	//IWebBrowser2 *m_webBrowser = m_ReflectionWnd.GetToolBar().GetBrowser();

	if(m_webBrowser){
		hr = m_webBrowser->QueryInterface(IID_IDispatch, (void**)&lpWBDisp);
		if(SUCCEEDED(hr)) {

			if (pDisp == lpWBDisp )
			{
				// Top-level Window object, so document has been loaded
				isPossiblyOuterFrame = isDefinatelyOuterFrame = 1;
			}
			//if(lpWBDisp)lpWBDisp->Release();
			if(lpWBDisp)SAFE_RELEASE(lpWBDisp);
		}
	}


	if(outerFrameIsInHistory){
		//m_ReflectionWnd.MessageBox(_T("DOCUMENT COMPLETE - beginning and end - already in history"), _T("SpoofGuard"), 0);
	
			//LED244
			IHTMLDocument2 *doc;
			int goodDoc = GetDocument(pDisp,&doc);	


			//always do an image check
			//to update for new images at frequently-visited domains
			//store result in repeatedImageFound

			//LED244
			repeatedImageFound = ImageCheck(doc,URL);

			//LED244
			if(goodDoc == S_OK)SAFE_RELEASE(doc);

		return S_OK;
	}




/*
	{

				_bstr_t url;
		try {
			url = _bstr_t(URL);
		}
		catch(_com_error ce) {
			TRACE("BEFORENAVIGATE2: Caught _bstr_t conversion error: %s\n", ce.ErrorMessage());
		}

		const int MAX_URL_LEN = 2100;
		TCHAR szCanonBuff[MAX_URL_LEN];
		DWORD buffLen = MAX_URL_LEN;
		InternetCanonicalizeUrl((const char *)url, szCanonBuff, &buffLen, 0);

		if(isDefinatelyOuterFrame) {
			CString tmp;
			tmp.Format("OUTERFRAME DOCUMENT COMPLETE: %s", szCanonBuff);
			//m_ReflectionWnd.MessageBox(tmp, _T("SpoofGuard"), 0);
		} else {
			CString tmp;
			tmp.Format("DOCUMENT COMPLETE: %s", szCanonBuff);
			
			//m_ReflectionWnd.MessageBox(tmp, _T("SpoofGuard"), 0);
		}

	}
*/



	{
	//----------------------------------------------------------
		_bstr_t url;
		try {
			url = _bstr_t(URL);
		}
		catch(_com_error ce) {
			TRACE("BEFORENAVIGATE2: Caught _bstr_t conversion error: %s\n", ce.ErrorMessage());
		}


		// Parse the given
		const int MAX_URL_LEN = 2100;   // IE only supports URLs up to 2083 characters
		TCHAR szCanonBuff[MAX_URL_LEN];
		DWORD buffLen = MAX_URL_LEN;

		URL_COMPONENTS urlComps;
		TCHAR szHost[MAX_URL_LEN];
		TCHAR szPath[MAX_URL_LEN];
		TCHAR szExtraInfo[MAX_URL_LEN];
		TCHAR szUserName[MAX_URL_LEN];

		memset(&urlComps, 0, sizeof(urlComps));
		urlComps.dwStructSize = sizeof(urlComps);
		urlComps.lpszHostName = szHost;
		urlComps.dwHostNameLength = MAX_URL_LEN;
		urlComps.lpszUrlPath = szPath;
		urlComps.dwUrlPathLength = MAX_URL_LEN;
		urlComps.lpszUserName = szUserName;
		urlComps.dwUserNameLength = MAX_URL_LEN;
		urlComps.lpszExtraInfo = szExtraInfo;
		urlComps.dwExtraInfoLength = MAX_URL_LEN;

	//----------------------------------------------------------


		//make sure we can parse the url
		if(!InternetCanonicalizeUrl((const char *)url, szCanonBuff, &buffLen, 0))
		{
			//we CAN'T parse the url. navigating anyway
			//
			//totalErrorMessage += (_T(" SpoofGuard was unable to canonicalize '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
			//if (isOuterFrame)
			//{
			//	UpdateStatus();
			//}
			//
			if(isDefinatelyOuterFrame) {
				flags[AVAILABLE_URL] = 1;
				warnings[AVAILABLE_URL] += (_T(" SpoofGuard was unable to canonicalize '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
			}
			//UpdateStatus();
		} else {
			//we CAN parse the url
			//continuing navigation

			if (!InternetCrackUrl(szCanonBuff, buffLen, 0, &urlComps))
			{
				//we CAN'T crack the url
				
				//totalErrorMessage += (_T(" SpoofGuard was unable to crack '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
				//if (isOuterFrame)
				//{
				//	UpdateStatus();
				//}
				if(isDefinatelyOuterFrame) {
					flags[AVAILABLE_URL] = 1;
					warnings[AVAILABLE_URL] += (_T(" SpoofGuard was unable to crack '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
				}
				//UpdateStatus();
				
				return S_OK;

			} else {
				INTERNET_PORT nport = urlComps.nPort;

				if (nport == INTERNET_DEFAULT_HTTPS_PORT) encryptedSite = 1;
				else encryptedSite = 0;

				if(m_pHistoryList) {
					if(! (m_pHistoryList->Find(urlComps.lpszHostName) == NULL) ) {
						/*
						if(isDefinatelyOuterFrame)
							rett = 1;
							*/
					} else {
						m_pHistoryList->AddHead(urlComps.lpszHostName);
					}
				}



			}
		}
	}
	
	//LED244
    IHTMLDocument2 *doc;
    int goodDoc = GetDocument(pDisp,&doc);	


	//always do an image check
    //to update for new images at frequently-visited domains
    //store result in repeatedImageFound

	//LED244
	repeatedImageFound = ImageCheck(doc,URL);


	if(rett) {
		m_ReflectionWnd.MessageBox(_T("RETT"), _T("DOCUMENTCOMPLETE"), 0); 

		if(goodDoc)SAFE_RELEASE(doc);
		return S_OK;
	}


	//LED244
    //do our link check, store result
    if(!flags[TEST_LINK]) badLinkFound = HTMLCheckLinks(doc,URL);

	//LED244
    //do our password/form check, store result
    if(!flags[TEST_INPUT]) inputFieldsFound = HTMLCheckInput(doc,URL);



	//LED244
    //add results,
    //print out warning string and send to UWToolBar
    //pop up warning if necessary and requested
    SecondAlert(pDisp, URL);
    
	//LED244
    if(goodDoc == S_OK)SAFE_RELEASE(doc);

	//the following lines are for performance checks
	//struct tm tm1, tm2;
	//char buf1[1024], buf2[1024];

   //_ftime( &timebuffer2 );

   	//wsprintf(buf1, "%u", timebuffer1.millitm);
	//wsprintf(buf2, "%u", timebuffer2.millitm);
	//m_ReflectionWnd.MessageBox(_T(buf1), _T("Before"), 0);
	//m_ReflectionWnd.MessageBox(_T(buf2), _T("After"), 0);

	//LED244
	UpdateStatus();


//LED244
    //we don't want to warn the user twice for the same site
    if(Thresh() && isDefinatelyOuterFrame && !alreadyWarned && m_ReflectionWnd.GetToolBar().GetCheckedValue())
    {

//LED244
/*
	CString tmp = "";
	int i;
	for(i=0;i<NUMBER_OF_TESTS - 1;i++)
		if(flags[i]){
			tmp += warnings[i];
		}
*/
//LED_MBOX
        //m_ReflectionWnd.MessageBox(tmp, _T("SpoofGuard"), MB_OK | MB_APPLMODAL | MB_ICONWARNING);


//LED244

		
		{
			int i = 0;
									CString tmp = "";
									for(i=0;i<NUMBER_OF_TESTS - 1;i++)
										if(flags[i]){
											tmp += warnings[i];
										}

									CString warnMsg;
									warnMsg.Format(_T("The URL that you have just loaded may be a spoof.\n\n%s\nDo you believe this may be a spoofed site?"),
										tmp);
									int choice = m_ReflectionWnd.MessageBox(warnMsg, _T("SpoofGuard"),
										MB_YESNO | MB_APPLMODAL | MB_ICONWARNING);

									if(choice == IDNO) {
										SendEmail(0);
									}
		}


    }

//LED223
}




//m_ReflectionWnd.MessageBox(_T("DOCUMENT COMPLETE END"), _T("SpoofGuard"), 0);

    return S_OK;
}


int CWarnBar::GetDocument(IDispatch* pDisp, IHTMLDocument2 **returnDoc) {

    IDispatch *myDispatch;
    IHTMLDocument2 *doc;
    HRESULT hr;

    //this just pulls up the outer frame from the browser

    //there are lots of SUCCEEDED() checks to make sure we don't do a null dereference

    //make sure it's a document
    //hr = myDispatch->QueryInterface(IID_IHTMLDocument2,(void**)&doc);

    //m_ReflectionWnd.MessageBox(_T("1"), _T("Link Check"), 0);


    if(!pDisp) return 0;
    //  hr = pDisp->QueryInterface(IID_IHTMLDocument2,(void**)&doc);


    IWebBrowser2* s_pWB = NULL;
    hr = pDisp->QueryInterface(IID_IWebBrowser2,(void**)&s_pWB);

    //m_ReflectionWnd.MessageBox(_T("2"), _T("Link Check"), 0);


    if(!SUCCEEDED(hr)){ return 0;}
    //m_ReflectionWnd.MessageBox(_T("3"), _T("Link Check"), 0);

    hr = s_pWB->get_Document(&myDispatch);


    if (!SUCCEEDED(hr)) return 0;
    //m_ReflectionWnd.MessageBox(_T("4"), _T("Link Check"), 0);


    //make sure it's a document
    hr = myDispatch->QueryInterface(IID_IHTMLDocument2,(void**)&doc);

    if (!SUCCEEDED(hr)) return 0;

    *returnDoc = doc;

    return 1;

}



//helper
//just changes the color of the light in UWToolBar

void CWarnBar::ChangeLight(int sum)
{

    int thresh = m_ReflectionWnd.GetToolBar().GetTotalAlertValue();

    if(sum >= thresh) {

        m_ReflectionWnd.GetToolBar().ChangeIcon(REDLIGHT);

    } else if( (sum >= (thresh/2)) && (sum != 0) ) {

        m_ReflectionWnd.GetToolBar().ChangeIcon(YELLOWLIGHT);

    } else {

        m_ReflectionWnd.GetToolBar().ChangeIcon(GREENLIGHT);
    }
}


//check called in second round (documentcomplete)
//implements HTML Check
//checks for password fields retrieved from the current page
//returns 0 if not activated (no problems)

int CWarnBar::HTMLCheckInput(IHTMLDocument2 *doc, VARIANT* URL){

    //there are lots of SUCCEEDED() checks to make sure we don't do a bad com dereference

    //m_ReflectionWnd.MessageBox(_T("Beginning Input Check"), _T("HTML Input Check"), 0);

    IDispatch *myDispatch;
    HRESULT hr;
    int ret = 0;


    //get the collection of forms
    IHTMLElementCollection *myCollection;

    hr = doc->get_forms(&myCollection);


    if(!SUCCEEDED(hr)){ return 0;}

    //get the length of the collection (answer)
    long answer;
    hr = myCollection->get_length(&answer);


    if(!SUCCEEDED(hr)){ return 0;}

    CString wMsg;
    HRESULT hResult;
    IHTMLFormElement  *myFormElement;

    int passwordRet;

    IDispatch *myDispatch2;
    long answer2;

    //there is a form in the site.
    if (answer > 0) isForm = 1;
    isSubmit = 0;
    passwordRet = 0;

    //iterate through the collection of forms

    for(long i = 0; i < answer; i++)
    {
        _variant_t index = i;
        hResult = myCollection->item( index, index, &myDispatch );


        //of course, each form is a collection of elements
        //load the current form into myFormElement

        if(SUCCEEDED(hResult)) hResult = myDispatch->QueryInterface(IID_IHTMLFormElement, (void **) &myFormElement);

        if(SUCCEEDED(hResult)) hResult = myFormElement->get_length(&answer2);


        //iterate through form for elements

        if(SUCCEEDED(hResult)) {
            for(long i = 0; i < answer2; i ++) {

                //m_ReflectionWnd.MessageBox(_T("Begin HTML for loop."), _T("HTML ForLoop Check"), 0);

                _variant_t index2 = i;
                hResult = myFormElement->item(index2, index2, &myDispatch2);

                //only if it's an inputTextElement/inputButtonElement do we care

                if (SUCCEEDED(hResult)) {

                    if (!passwordRet) {
                        ret = HTMLCheckPasswords(*myDispatch2);
                        if (ret) passwordRet = 1;
                    }

                    //check for submit buttons
                    if (!isSubmit) HTMLCheckButtons(*myDispatch2);
                }
            }
        }
    }

    //we're done, free everything
    if(!SUCCEEDED(hr)){ return 0;}

    //myDispatch->Release();
    //s_pFrameWB->Release();

    return passwordRet;

}


//checks for password fields
//returns 1 if there is a password field in the current site
int CWarnBar::HTMLCheckPasswords(IDispatch &myDispatch2)
{

    IHTMLInputTextElement *myElement;
    BSTR myName;

    //load each element from form

    HRESULT hResult = myDispatch2.QueryInterface(IID_IHTMLInputTextElement, (void **) &myElement);

    if (!SUCCEEDED(hResult)) return 0;

    //get the type of text element
    hResult = myElement->get_type(&myName);

    if(!SUCCEEDED(hResult)) return 0;

    //and finally, we only care if it's a password field

    CString wMsg = (LPCWSTR)myName;
    if(!wMsg.CompareNoCase("password")){
        return 1;
    }

    return 0;
}


//also care if it's an inputSubmitElement
//also check if the Submit Element has value "Search" or "Find" (ie. it's a search bar)
//if it's a search bar, reset isForm to 0
//user does not need to be warned about a search bar

void CWarnBar::HTMLCheckButtons(IDispatch &myDispatch2)
{
    IHTMLInputButtonElement *buttonElement;

    BSTR buttonName;
    BSTR buttonValue;

    HRESULT hResult;
    CString wMsg;


    hResult = myDispatch2.QueryInterface(IID_IHTMLInputButtonElement, (void **) &buttonElement);

    if(!SUCCEEDED(hResult)) return;


    //get the type of button element
    hResult = buttonElement->get_type(&buttonName);
    if(!SUCCEEDED(hResult)) return;


    //we only care if it's a submit type button
    wMsg = (LPCWSTR)buttonName;
    //m_ReflectionWnd.MessageBox(_T(wMsg), _T("Button Check"), 0);

    if(wMsg.CompareNoCase("submit") != 0) return;


    //it's a submit type button

    hResult = buttonElement->get_value(&buttonValue);
    if (!SUCCEEDED(hResult)) return;

    wMsg = (LPCWSTR)buttonValue;

    //m_ReflectionWnd.MessageBox(_T(wMsg), _T("Button Check"), 0);

    //check if the value has "search" or "find": set isForm to 0;
    if (wMsg.Find("Search") != -1 || wMsg.Find("SEARCH") != -1 ||
        wMsg.Find("Find") != -1 || wMsg.Find("FIND") != -1) {

        //m_ReflectionWnd.MessageBox(_T("Found search match"), _T("Button Check"), 0);

        isForm = 0;
    }

    //check if the value has "submit" or "sign": set isSubmit to 1, and reset isForm to 1;
    if (wMsg.Find("Submit") != -1 || wMsg.Find("SUBMIT") != -1 ||
        wMsg.Find("Sign") != -1 || wMsg.Find("SIGN") != -1) {

        isSubmit = 1;
        isForm = 1;
    }

}


//Check called in second round (documentcomplete)
//implements Link Check
//basically the same as HTMLCheckInput
//go through collection of forms on the page

int CWarnBar::HTMLCheckLinks(IHTMLDocument2 *doc, VARIANT* URL){

    //m_ReflectionWnd.MessageBox(_T("STARTING CHECK LINKS"), _T("Link Check"), 0);

    int ret = 0;


    IDispatch *myDispatch;
    //IHTMLDocument2 *doc;
    HRESULT hr;


    //there are lots of SUCCEEDED() checks to make sure we don't do a null dereference

    //collection - this time a collection of forms
    IHTMLElementCollection *myCollection;

    //this is where this is a little different from HTMLCheckInput

    if(!doc) return 0;

    //get collection of links
    hr = doc->get_links(&myCollection);

    if(!SUCCEEDED(hr)) return 0;

    //get length of collection of links
    long answer;
    long badLinkCount = 0;

    hr = myCollection->get_length(&answer);

    if(!SUCCEEDED(hr)) return 0;

    HRESULT hResult;
    IHTMLAnchorElement *myLinkElement;


    //iterate through collection of links
    for(long i = 0; i < answer; i++)
    {

        _variant_t index = i;
        //pull up each link
        hResult = myCollection->item( index, index, &myDispatch );


        if(SUCCEEDED(hResult)) {
            //make sure it's a link
            hResult = myDispatch->QueryInterface(IID_IHTMLAnchorElement, (void **) &myLinkElement);


			if(SUCCEEDED(hResult)){

                BSTR bstr;
                CString rstrURL;

                //get href from link
                hResult = myLinkElement->get_href(&bstr);

                //myLinkElement->Release();
                SAFE_RELEASE(myLinkElement);

                if(SUCCEEDED(hResult)){


                    //parse URL
                    _bstr_t bstrHREF(bstr, FALSE);
                    rstrURL = (LPCSTR)bstrHREF;


                    //let's get something we can work with

                    const int MAX_URL_LEN = 2100;   // IE only supports URLs up to 2083 characters
                    TCHAR szCanonBuff[MAX_URL_LEN];
                    DWORD buffLen = MAX_URL_LEN;

                    URL_COMPONENTS urlComps;
                    TCHAR szHost[MAX_URL_LEN];
                    TCHAR szPath[MAX_URL_LEN];
                    TCHAR szExtraInfo[MAX_URL_LEN];
                    TCHAR szUserName[MAX_URL_LEN];

                    memset(&urlComps, 0, sizeof(urlComps));
                    urlComps.dwStructSize = sizeof(urlComps);
                    urlComps.lpszHostName = szHost;
                    urlComps.dwHostNameLength = MAX_URL_LEN;
                    urlComps.lpszUrlPath = szPath;
                    urlComps.dwUrlPathLength = MAX_URL_LEN;
                    urlComps.lpszUserName = szUserName;
                    urlComps.dwUserNameLength = MAX_URL_LEN;
                    urlComps.lpszExtraInfo = szExtraInfo;
                    urlComps.dwExtraInfoLength = MAX_URL_LEN;


                    //only go on if we can parse url
                    if(!InternetCanonicalizeUrl((const char *)rstrURL, szCanonBuff, &buffLen, 0)) {

                        //we can't get the url
                    } else if(!InternetCrackUrl(szCanonBuff, buffLen, 0, &urlComps)) {

                    } else {


                        //run First Round checks on the parsed
                        if(FirstAlertClean(urlComps)){
                            //if it's problematic, add to count
                            badLinkCount++;
                            //if we already have enough bad links, we're done here
                            if( (badLinkCount > (answer / 4)) && (badLinkCount > 0) ) break;
                        }
                    }
			    }
            }
        }
    }

    //m_ReflectionWnd.MessageBox(_T("8"), _T("Link Check"), 0);

    if(!SUCCEEDED(hr)){ return 0;}

    //considered problematic if a quarter of the links look suspicious
    ret = (badLinkCount > (answer / 4)) && (badLinkCount > 0);

    //Changes the color of the links
    //if we decide there are enough bad links.
    
    //i would not suggest turning this back on.
    //there's a non-visible button in the configdlg that is linked to this.
   
	/*
	if(ret && m_ReflectionWnd.GetToolBar().GetCheckedLValue())
    {
        VARIANT var;
        var.vt = VT_I4;
        // Lawn green color. Strange that this doesn't support the RGB() macro (bytes are reversed).
        var.lVal = 0x7CFC00;
        if (doc) HRESULT hrs = doc->put_linkColor(var);
    }
*/

	/*
	{
	    VARIANT var;
        var.vt = VT_I4;
        // Lawn green color. Strange that this doesn't support the RGB() macro (bytes are reversed).
        var.lVal = 0x7CFC00;
        if (doc) HRESULT hrs = doc->put_linkColor(var);
	}
	*/

    
    //m_ReflectionWnd.MessageBox(_T("ENDING CHECK LINKS"), _T("Link Check"), 0);

    return ret;
}

//Called from second round   (documentcomplete)
//implements Image Check
//starts out the same as the other two first-round checks
//then hashes data to file

int CWarnBar::ImageCheck(IHTMLDocument2 *doc, VARIANT* URL)
{
    IDispatch *myDispatch;
    //IHTMLDocument2 *doc;

    int ret = 0;

    //get the collection of IMAGES
    IHTMLElementCollection *myCollection;
    HRESULT hr = doc->get_images(&myCollection);

    if(!SUCCEEDED(hr)) return 0;

    //get length of collection (answer)
    long answer;
    hr = myCollection->get_length(&answer);

    if(!SUCCEEDED(hr))  return 0;


    HRESULT hResult;
    IHTMLImgElement *myImgElement;


    //counts of good hashes
    int goodHashes = 0;

    //where all of our hashes are stored
    BYTE **imageHashArray = new BYTE *[2*answer];

    //length of our hashes.
    //set by hash functions
    //should come out to 20
    unsigned int imageHashLength = 0;
    unsigned int domainHashLength = 0;

    //iterate through the collection of forms

    for(long i = 0; i < answer; i++)
    {

//m_ReflectionWnd.MessageBox(_T("ATTEMPT"), _T("Image Check"), 0);

        _variant_t index = i;
        hResult = myCollection->item( index, index, &myDispatch );

        if(SUCCEEDED(hResult)) {

            //make sure this is an imageElement
            hResult = myDispatch->QueryInterface(IID_IHTMLImgElement, (void **) &myImgElement);

            if(SUCCEEDED(hResult)){

                //components of image element
                //the image element interface is just a collection of stats
                BSTR imgHref;
                BSTR imgSizeBstr;
                unsigned int imgSize;
                long height = 0;
                long width = 0;



                //make sure we can get all the attributes of the image
                if( SUCCEEDED( myImgElement->get_href(&imgHref) )                   &&
                    SUCCEEDED( myImgElement->get_fileSize((BSTR *)&imgSizeBstr) )   &&
                    ( ( imgSize = BstrToInt(imgSizeBstr) ) > 0 )                    &&
                    SUCCEEDED( myImgElement->get_height(&height) )                  &&
                    SUCCEEDED( myImgElement->get_width(&width) )                    ) {

                    //make sure all the attributes are acceptable
                    if( 
						( 
						  (height >= IMG_MINHEIGHT &&
                           height <= IMG_MAXHEIGHT )
							||
                          (width >= IMG_MINWIDTH   &&
                           width <= IMG_MAXWIDTH   )
						)
						 &&
                        (imgSize >= IMG_MINSIZE  &&
                         imgSize <= IMG_MAXSIZE  ) 
					  )
					{

                        //make a new image buffer
                        BYTE *imageBuffer = new BYTE[imgSize + 8];

                        //if we don't have enough space, return
                        if(imageBuffer) {
                            ZeroMemory((void *)imageBuffer,imgSize);

                            //get the actual image
                            if(ReadImageIntoBuffer(imgHref,imageBuffer,imgSize)) {

                                PBYTE imageHash;
                                DWORD iHashLength = 0;
                                //hash the image into imageHash
                                if( (imageHash = HashBuffer(imageBuffer,imgSize,&iHashLength)) ) {

                                    PBYTE domainHash;
                                    DWORD dHashLength = 0;

                                    //now hash the domain name, to store with the image
                                    if(m_ReflectionWnd.GetToolBar().GetCurrentDomain()){

                                        unsigned int len = m_ReflectionWnd.GetToolBar().GetCurrentDomain().GetLength();

                                        //store domain name here
                                        LPTSTR lpsz = new TCHAR[ len + 1];
                                        if(_tcscpy(lpsz, m_ReflectionWnd.GetToolBar().GetCurrentDomain())) {

                                            //hash both into buffers
                                            //if( (domainHash = HashBuffer((BYTE *)imgHref,sizeof(OLECHAR)*SysStringLen(imgHref),&dHashLength)) ){
                                            if( (domainHash = HashBuffer((BYTE *)lpsz,len,&dHashLength)) ){

                                                //stick pointers to buffers in our hash array
                                                //we don't write to the file until the end
                                                imageHashLength = iHashLength;
                                                domainHashLength = dHashLength;
                                                imageHashArray[goodHashes++] = imageHash;
                                                imageHashArray[goodHashes++] = domainHash;
//m_ReflectionWnd.MessageBox(_T("SUCCESS"), _T("Image Check"), 0);

                                            } else {
//m_ReflectionWnd.MessageBox(_T("FAIL_1"), _T("Image Check"), 0);
                                                delete imageHash;
                                            }
                                        } else {
//m_ReflectionWnd.MessageBox(_T("FAIL_2"), _T("Image Check"), 0);
                                            delete imageHash;
                                        }
                                    } else {
//m_ReflectionWnd.MessageBox(_T("FAIL_3"), _T("Image Check"), 0);
                                        delete imageHash;
                                    }
                                } else {
//m_ReflectionWnd.MessageBox(_T("FAIL_4"), _T("Image Check"), 0);
								}
                            } else {
//m_ReflectionWnd.MessageBox(_T("FAIL_5"), _T("Image Check"), 0);
							}
                            delete imageBuffer;
                        } else {
//m_ReflectionWnd.MessageBox(_T("FAIL_6"), _T("Image Check"), 0);
						}
                    } else {

int h = (height >= IMG_MINHEIGHT && height <= IMG_MAXHEIGHT );
int w  = (width >= IMG_MINWIDTH   && width <= IMG_MAXWIDTH   );
int s   = (imgSize >= IMG_MINSIZE  && imgSize <= IMG_MAXSIZE  );

CString x;
x.Format("FAIL_7: height: %d-%d, width: %d-%d, size %d: %d - %d - %d",h,height, w,width, s, IMG_MINSIZE, imgSize, IMG_MAXSIZE);
m_ReflectionWnd.MessageBox(x, _T("Image Check"), 0);


					}
                } else {
//m_ReflectionWnd.MessageBox(_T("FAIL_8"), _T("Image Check"), 0);
	
				}
            }
            //myImgElement->Release();
            SAFE_RELEASE(myImgElement);
        }
    }

    //if we find any bad hashes in IterateHashFile, return 1
    if(goodHashes > 0 && IterateHashFile(imageHashArray,goodHashes,imageHashLength,domainHashLength)) {
        ret = 1;
    }

    //cleanup
    for (long j = 0; j<goodHashes; j++){
        delete imageHashArray[j];
    }
    delete imageHashArray;

    //myDispatch->Release();
    //s_pFrameWB->Release();

    return ret;
}

//takes in array of hashes
//arranged image:domain:image:domain...
//writes them out to file, and returns 1 if there are duplicate image hashes on diffrent domain hashes

int CWarnBar::IterateHashFile(BYTE *hashArray[], unsigned int numHashes, unsigned int imageHashLength, unsigned int domainHashLength){

    int ret = 0;
    FILE *fp;
    int res = 0;
    unsigned int count = 0;

	
		
		int *foundMatch   = new int [numHashes];
		int *alreadyThere = new int [numHashes];
	
	{
		int i = 0;
		for(i = 0; i < numHashes; i++) {
			foundMatch[i] = 0;
			alreadyThere[i] = 0;
		}
	}


    //check for duplicates first
    if( FileExists() ) {



        //open file
        fp = fopen(IMAGE_FILENAME,"rb");
        if(!fp) return 0;
        res = fread(&count,1,sizeof(unsigned int),fp);

        if(!res) {
            _fcloseall();
            return ret;
        }
        //there should be at least 'count' items in the file
        //store file hashes here, one at a time
        BYTE *ih = new BYTE[imageHashLength + 1];
        BYTE *dh = new BYTE[domainHashLength + 1];

        //just in case
        ih[imageHashLength] = '\0';
        dh[domainHashLength] = '\0';







        //iterate through file
        for(int i = 0; i < MAX_IMAGE_HASHES; i++){

            //read an image:domain hash pair from file from file
            res = fread(ih,1,imageHashLength,fp);
            if(!res) break;

            res = fread(dh,1,domainHashLength,fp);
            if(!res) break;






            //compare to image:domain hash pair passed in
            for(unsigned int j = 0; j < numHashes; j += 2) {


/*
	int foundMatch = 0;
	int alreadyThere = 0;
*/

				if( alreadyThere[j] ) {
					continue;
				}

                int images  = memcmp(ih,hashArray[j]    , imageHashLength);
                int domains = memcmp(dh,hashArray[j + 1],domainHashLength);
/*
				{
//m_ReflectionWnd.MessageBox(_T("STARTING"), _T("Image Check"), 0);
				}
*/
/*
				{
CString compare;
compare.Format("images: %d, domains: %d, old: %s, new: %s",images, domains,dh,hashArray[j+1]);
//m_ReflectionWnd.MessageBox(compare, _T("Image Check"), 0);
				}
*/


				if( (images == 0) && (domains == 0) ) {
					alreadyThere[j] = 1;
					//break;
/*
CString compare;
compare.Format("ALREADY THERE: old: %s, new: %s",dh,hashArray[j+1]);
//m_ReflectionWnd.MessageBox(compare, _T("Image Check"), 0);
*/
				}

                //stop if we find a match
                //if( (!images) && domains) {
				if( (images == 0) && (domains != 0) ) {
/*
CString compare;
compare.Format("MATCH: old: %s, new: %s",dh,hashArray[j+1]);
//m_ReflectionWnd.MessageBox(compare, _T("Image Check"), 0);
*/
                    foundMatch[j] = 1;
                    //break;
                }

				if( (foundMatch[j] == 1) && !(alreadyThere[j] == 1) ){
/*
CString compare;
compare.Format("ALARM: old: %s, new: %s",dh,hashArray[j+1]);
//m_ReflectionWnd.MessageBox(compare, _T("Image Check"), 0);
*/
					ret = 1;	
					break;
				}
            }

/*
            if(foundMatch && !alreadyThere) {
                ret = 1;
                break;
            }
*/

			if(ret) break;

        }

        fclose(fp);
        delete ih;
        delete dh;


    } else  {

        //create the file if it doesn't exist
        fp = fopen(IMAGE_FILENAME,"w+b");
        if(!fp) {
			
			delete foundMatch;
			delete alreadyThere;

            return ret;
        }
        fclose(fp);
    }





    //if the user selects to hash new images, write them out
    if(m_ReflectionWnd.GetToolBar().GetCheckedIValue()) {

        //open file
        fp = fopen(IMAGE_FILENAME,"r+b");
        if(!fp) {
            return ret;
        }



        //writing is done as a wraparound
        //when we hit what we've chosen as the length of our file (MAX_IMAGE_HASHES)
        //we go back to 0 and overwrite again
        fpos_t writepos = 0 + sizeof(unsigned int) + count*(imageHashLength + domainHashLength);

        for(unsigned int k = 0; k<numHashes; k += 2) {

            const fpos_t wp = writepos;

            //set position of file pointer and write
            if(!fsetpos(fp,&wp)) {

                res = fwrite(hashArray[k],1,imageHashLength,fp);
                if(!res) {
                    fclose(fp);
                    return ret;
                }
                res = fwrite(hashArray[k + 1],1,domainHashLength,fp);
                if(!res) {
                    fclose(fp);
                    return ret;
                }
            }
            //find next spot to write
            count = (count + 1) % MAX_IMAGE_HASHES;

            //multiply by hash length (offset by 4 so we can store a count at the front of the file)
            writepos = 0 + sizeof(unsigned int) + count*(imageHashLength + domainHashLength);
        }

        //write count out to file
        writepos = 0;
        if(!fsetpos(fp,&writepos)) {
            if(fwrite(&count,1,sizeof(unsigned int),fp)) {

            }
        }

        fclose(fp);
    }



	delete foundMatch;
	delete alreadyThere;

    return ret;
}





//just checks if file exists
int CWarnBar::FileExists(){
    FILE *fp = fopen(IMAGE_FILENAME,"rb");
    if(fp){
        fclose(fp);
        return 1;
    }
    return 0;
}


//just checks if password file exists
//if it doesn't exist, it creates one
//returns the pointer to the file
FILE* CWarnBar::OpenPasswordFile() {

    FILE *fp;
    fp = fopen(PASSWD_FILENAME, "r+");
    if (!fp) {
        fp = fopen(PASSWD_FILENAME, "w+");
        if (!fp) return NULL;
    }
    return fp;
}


//opens a file to add a new line to the file
FILE* CWarnBar::OpenPasswordFileAdd(){
    FILE *fp;
    fp = fopen(PASSWD_FILENAME, "a");
    if (!fp) return NULL;
    else return fp;
}


//just hashes a buffer of size imageSize.
//this is also used for domain hashes
PBYTE CWarnBar::HashBuffer(BYTE *imageBuffer, unsigned int imageSize, DWORD *hashLength){

    HCRYPTHASH hHash;
    DWORD dwBufferSize = 0;;
    DWORD dwValue;
    PBYTE hashBuffer;
    DWORD iSize = 0 + imageSize;
    HCRYPTPROV hProv;

    //microsoft hashing from Visual Studio example

    //BEWARE VISUAL STUDIO EXAMPLE on hashing
    //there was a bug in the sample code
    //the placement of deValue was incorrect in the second CryptGetHashParam (i believe)

    if(CryptAcquireContext(&hProv,NULL,MS_DEF_PROV ,PROV_RSA_FULL,  CRYPT_VERIFYCONTEXT  )){

        if(CryptCreateHash(hProv,CALG_SHA,0,0,&hHash)) {

            if(CryptHashData(hHash,imageBuffer,iSize,0)){

                dwBufferSize = sizeof(DWORD);
                if(CryptGetHashParam(hHash,HP_HASHSIZE,(BYTE *)&dwValue,&dwBufferSize,0)){

                    if( (hashBuffer = new unsigned char [dwValue + 1]) ){

                        if(CryptGetHashParam(hHash,HP_HASHVAL,hashBuffer,&dwValue,0)){

                            hashBuffer[dwValue] = '\0';

                            *hashLength = dwValue;
                            return hashBuffer;

                        }else {

                            delete hashBuffer;

                        }
                    }
                }
            }
        }
        CryptReleaseContext(hProv,0);
    }

    return NULL;
}


//reads the given image into given buffer
int CWarnBar::ReadImageIntoBuffer(const CString& imageURL, BYTE *imageBuffer, unsigned int imageSize){

    //open an 'internet' connection
    //in reality, we're just using this interface to get the image from the cache
    HINTERNET hInet = InternetOpen(_T("SpoofGuard"),INTERNET_OPEN_TYPE_DIRECT,NULL,NULL,INTERNET_FLAG_FROM_CACHE);

    if(hInet){
        HINTERNET hInetUrl = InternetOpenUrl(hInet,imageURL,NULL,NULL,0,0);

        if(hInetUrl){

            DWORD bytesRead;
            //put image into buffer
            if(InternetReadFile(hInetUrl,(LPVOID)imageBuffer,imageSize,&bytesRead)){

                if(bytesRead == imageSize) {

                    return 1;

                }
            }
        }
    }
    return 0;
}

//conversion from BSTR to int, so I could get the image size (stored as BSTR)
unsigned int CWarnBar::BstrToInt(BSTR bstr)
{
    if(!bstr) {
        return 0;
    }

    if(bstr[0] == L'-') {

        return 0;
    }

    unsigned int len = SysStringLen(bstr);
    int multiplier = 1;
    int sum = 0;


    for(int i = len - 1;i >= 0;i--) {
        sum += multiplier * (bstr[i] - 48);
        multiplier *= 10;
    }

    return sum;
}


STDMETHODIMP CWarnBar::SendEmail(int isBefore)
{
	if (AfxSocketInit()) 	{

//m_ReflectionWnd.MessageBox(_T("Starting Email"), _T("SpoofGuard"), 0);
		
		CSMTPConnection smtp;
		smtp.Connect("theory.stanford.edu");

		CSMTPMessage m;
		m.AddRecipient(CSMTPAddress("led242@theory.stanford.edu"));
		m.m_From = CSMTPAddress("led242@stanford.edu");
		m.m_sSubject = "Spoofguard Automated Report -- 3";


		CString head = _T("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");

		CString version = "<version level=\"1\" / > \n";

		CString when;
		when.Format("<isBefore level=\"%d\" / > \n",isBefore);



		CString domain;
		domain.Format("<domain level=\"%d\" flag=\"%d\" warning=\"%s\" dist=\"%d\" hist=\"%d\" / > \n",
			m_ReflectionWnd.GetToolBar().GetDWeightValue(),
			flags[TEST_DOMAIN],
			warnings[TEST_DOMAIN],
			m_ReflectionWnd.GetToolBar().GetDistValue(),
			m_ReflectionWnd.GetToolBar().GetHistValue());
			




		CString url;
		url.Format("<url level=\"%d\" flag=\"%d\" warning=\"%s\" / > \n",
			m_ReflectionWnd.GetToolBar().GetUWeightValue(),
			
			flags[TEST_URL],
			
			warnings[TEST_URL]);
			

		CString email;
		email.Format("<email level=\"%d\" flag=\"%d\" warning=\"%s\" / > \n",
			m_ReflectionWnd.GetToolBar().GetPWeightValue(),
			
			flags[TEST_EMAIL],
			
			warnings[TEST_EMAIL]);
			

		CString input;
		input.Format("<input level=\"%d\" flag=\"%d\" warning=\"%s\" / > \n",
			m_ReflectionWnd.GetToolBar().GetHWeightValue(),
			
			flags[TEST_INPUT],
			
			warnings[TEST_INPUT]);
			

		CString link;
		link.Format("<link level=\"%d\" flag=\"%d\" warning=\"%s\" sensitivity=\"%d\" / > \n",
			m_ReflectionWnd.GetToolBar().GetLWeightValue(),
			
			flags[TEST_LINK],
			
			warnings[TEST_LINK],
			
			m_ReflectionWnd.GetToolBar().GetLSensitivityValue());
			

		CString image;
		image.Format("<image level=\"%d\" flag=\"%d\" warning=\"%s\" / > \n",
			m_ReflectionWnd.GetToolBar().GetIWeightValue(),
			
			flags[TEST_IMAGE],
			
			warnings[TEST_IMAGE]);
			

		CString https;
		https.Format("<https level=\"%d\" flag=\"%d\" warning=\"%s\" / > \n",
			m_ReflectionWnd.GetToolBar().GetXWeightValue(),
			
			flags[TEST_HTTPS],
			
			warnings[TEST_HTTPS]);
			


		CString total;
		total.Format("<total level=\"%d\" / > \n",
			m_ReflectionWnd.GetToolBar().GetTotalAlertValue() );
			


		CString body = head + version + when + domain + url + email + input + link + image + https + total;


		m.AddTextBody(body);




		smtp.SendMessage(m);
	}
	
	return S_OK;

}


/*
HRESULT _stdcall CWarnBar::NewWindow2( IDispatch** &ppDisp, VARIANT_BOOL* &Cancel){

  //return SetSite(globalpUnkSite);

    }
*/

/*
HRESULT _stdcall CWarnBar::NavigateComplete2(IDispatch* pDisp, VARIANT* URL){

  }
*/







//this is fired before the browser attempts to navigate to a page
//so this is where our first-round checks are done
//at this point we only have access to the attempted url (frame name, headers, etc)
//but we can cancel navigation by changing the value of Cancel

HRESULT __stdcall CWarnBar::BeforeNavigate2(IDispatch *pDisp, VARIANT *URL, VARIANT *Flags,
                                            VARIANT *TargetFrameName, VARIANT *PostData,
                                            VARIANT *Headers, VARIANT_BOOL *Cancel)
{

	//the following line is for performance check
	//time(&before);
   //_ftime( &timebuffer1 );

    // Only do work while visible in IE
    if(!m_bShow)
        return S_OK;

    //return if not initialized
    if(!registered)
        return S_OK;









//    beforeNaved = 1;
    int isOuterFrame = 0;




    
	//check if we're in the outer frame, same as documentcomplete
	//LED222
	//if(0)
	{


		//IUnknown*  pUnk;
		LPDISPATCH lpWBDisp;
		HRESULT    hr;
		//IWebBrowser2 *m_webBrowser = m_ReflectionWnd.GetToolBar().GetBrowser();

		if(m_webBrowser){
			hr = m_webBrowser->QueryInterface(IID_IDispatch, (void**)&lpWBDisp);

			if(SUCCEEDED(hr)) {

				if (pDisp == lpWBDisp ) {

					// Top-level Window object, so document has been loaded
					isOuterFrame = 1;
	//                //beforeNaved = 1;
				}
				//if(lpWBDisp)lpWBDisp->Release();
				if(lpWBDisp)SAFE_RELEASE(lpWBDisp);
			}
		}

	//LED223
	}


	/*
	{

		_bstr_t url;
		try {
			url = _bstr_t(URL);
		}
		catch(_com_error ce) {
			TRACE("BEFORENAVIGATE2: Caught _bstr_t conversion error: %s\n", ce.ErrorMessage());
		}

		const int MAX_URL_LEN = 2100;
		TCHAR szCanonBuff[MAX_URL_LEN];
		DWORD buffLen = MAX_URL_LEN;
		InternetCanonicalizeUrl((const char *)url, szCanonBuff, &buffLen, 0);

		if(isOuterFrame) {
			CString tmp;
			tmp.Format("OUTERFRAME BEFORE NAVIGATE: %s", szCanonBuff);
//			m_ReflectionWnd.MessageBox(tmp, _T("SpoofGuard"), 0);
		} else {
			CString tmp;
			tmp.Format("BEFORE NAVIGATE: %s", szCanonBuff);
//			m_ReflectionWnd.MessageBox(tmp, _T("SpoofGuard"), 0);
		}

	}
	*/

//    encryptedSite = 0;



	//SendEmail();


	if(isOuterFrame) 

//LED222
	//if(0)
	{
		outerDomain = "";
		int i = 0;
		for(i=0;i<NUMBER_OF_TESTS;i++){
			flags[i] = 0;
			warnings[i] = "";
		}

		cancelledNavigation = 0;

		//we don't want to do much if we're not in the outer frame
		outerFrameIsInHistory = 0;
		alreadyWarned = 0;

	//----------------------------------------------------------
		_bstr_t url;
		try {
			url = _bstr_t(URL);
		}
		catch(_com_error ce) {
			TRACE("BEFORENAVIGATE2: Caught _bstr_t conversion error: %s\n", ce.ErrorMessage());
		}


		// Parse the given
		const int MAX_URL_LEN = 2100;   // IE only supports URLs up to 2083 characters
		TCHAR szCanonBuff[MAX_URL_LEN + 7];
		TCHAR szCanonBuffOrig[MAX_URL_LEN + 7];
		DWORD buffLen = MAX_URL_LEN;

		URL_COMPONENTS urlComps;
		TCHAR szHost[MAX_URL_LEN];
		TCHAR szPath[MAX_URL_LEN];
		TCHAR szExtraInfo[MAX_URL_LEN];
		TCHAR szUserName[MAX_URL_LEN];

		memset(&urlComps, 0, sizeof(urlComps));
		urlComps.dwStructSize = sizeof(urlComps);
		urlComps.lpszHostName = szHost;
		urlComps.dwHostNameLength = MAX_URL_LEN;
		urlComps.lpszUrlPath = szPath;
		urlComps.dwUrlPathLength = MAX_URL_LEN;
		urlComps.lpszUserName = szUserName;
		urlComps.dwUserNameLength = MAX_URL_LEN;
		urlComps.lpszExtraInfo = szExtraInfo;
		urlComps.dwExtraInfoLength = MAX_URL_LEN;
    
	//----------------------------------------------------------


		
//m_ReflectionWnd.MessageBox(url, _T("URL"), 0);

		//make sure we can parse the url
		if(!InternetCanonicalizeUrl((const char *)url, szCanonBuffOrig, &buffLen, 0))
		{
			//we CAN'T parse the url. navigating anyway
			/*
			totalErrorMessage += (_T(" SpoofGuard was unable to canonicalize '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
			if (isOuterFrame)
			{
				UpdateStatus();
			}
			*/
			flags[AVAILABLE_URL] = 1;
			warnings[AVAILABLE_URL] += (_T(" SpoofGuard was unable to interpret (canonicalize) '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
			//UpdateStatus();
		} else {
			//we CAN parse the url
			//continuing navigation

			int kill = 0;

			TCHAR *scb = szCanonBuffOrig;

			CString prefix = TESTING_PREFIX;


			

//CString pre;
//pre.Format("diff: %d",((CString)scb).Find(prefix));
//m_ReflectionWnd.MessageBox(pre, _T("SpoofGuard"), 0);

			if(((CString)scb).Find(prefix) == 0){

//m_ReflectionWnd.MessageBox(_T("EDITING"), _T("SpoofGuard"), 0);

				scb = szCanonBuffOrig + (TESTING_INDEX);

//m_ReflectionWnd.MessageBox(scb,"1",0);


				strcpy(szCanonBuff,"http://");

								//make sure we can parse the url
				if(!InternetCanonicalizeUrl((const char *)scb, szCanonBuff + 7, &buffLen, 0))
				{
					flags[AVAILABLE_URL] = 1;
					warnings[AVAILABLE_URL] += (_T(" SpoofGuard was unable to interpret (canonicalize) '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
					kill = 1;
				} else {
//m_ReflectionWnd.MessageBox(szCanonBuff,"2",0);
					scb = szCanonBuff;
				}
			} else {
//m_ReflectionWnd.MessageBox(_T("NOT EDITING"), _T("SpoofGuard"), 0);
			}

//m_ReflectionWnd.MessageBox(scb,"3",0);

			if(kill == 0){
				if (!InternetCrackUrl((const char *)scb, buffLen, 0, &urlComps)) {
					//we CAN'T crack the url
					/*
					totalErrorMessage += (_T(" SpoofGuard was unable to crack '") + url + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
					if (isOuterFrame)
					{
						UpdateStatus();
					}
					*/
					flags[AVAILABLE_URL] = 1;
					CString tmp;
					tmp.Format(_T(" SpoofGuard was unable to crack '%s'. SpoofGuard will not be able to check this URL.\r\n"),scb);
					//warnings[AVAILABLE_URL] += (_T(" SpoofGuard was unable to crack '") + scb + _T("'. SpoofGuard will not be able to check this URL.\r\n"));
					warnings[AVAILABLE_URL] += tmp;
					//UpdateStatus();
				} else {


					outerDomain.Format("%s",urlComps.lpszHostName);

					//if(urlComps.lpszHostName.CompareNoCase(TESTING_PREFIX) >= TESTING_INDEX) {
					//if(1){
					//	urlComps.lpszHostName = szHost + TESTING_INDEX;
					//}


					/*
					CString Msg;
					if(isOuterFrame) Msg = "OUTERFRAME ";
					Msg = "" + Msg +""+ urlComps.lpszHostName+"";
//					m_ReflectionWnd.MessageBox(Msg, _T("SpoofGuard"), 0);
					*/


    
					//we CAN crack the url
					//m_ReflectionWnd.GetToolBar().ChangeIcon(GREENLIGHT);

					if ( !
							(
								(urlComps.nScheme == INTERNET_SCHEME_FTP)
								|| (urlComps.nScheme == INTERNET_SCHEME_GOPHER)
								|| (urlComps.nScheme == INTERNET_SCHEME_HTTP)
								|| (urlComps.nScheme == INTERNET_SCHEME_HTTPS)
							)
						)
					{
						/*
						totalErrorMessage += _T(" SpoofGuard has ignored '") + url + _T("' because it does not recognize this URL's protocol. Ensure that the URL entered begins with ftp://, gopher://, http://, or https://.\r\n");
						if(isOuterFrame)UpdateStatus();
						cancelledNavigation = 1;
						*/
						flags[AVAILABLE_URL] = 1;
						warnings[AVAILABLE_URL] += _T(" SpoofGuard has ignored '") + url + _T("' because it does not recognize this URL's protocol. Ensure that the URL entered begins with ftp://, gopher://, http://, or https://.\r\n");
						cancelledNavigation = 1;
						//UpdateStatus();
					} else {


						//Retrieving Post Data
						//LED242 -- make sure of what this does
						if(m_ReflectionWnd.GetToolBar().GetCheckedLValue())
							PostDataCheck(PostData, Cancel);

						if(!m_pHistoryList)
						{
							//we can't get ahold of our history
							//navigating anyway
							//ShowNoHistoryMessage(urlComps);
							flags[AVAILABLE_HISTORY] = 1;
							warnings[AVAILABLE_HISTORY] =  _T(" SpoofGuard was unable to access your Internet Explorer history.\r\n");
							outerFrameIsInHistory = 1;
							//UpdateStatus();

						} else {

							//we CAN get a hold of our history
							if(! (m_pHistoryList->Find(urlComps.lpszHostName) == NULL) )
							{
								//is in our history
								//no problem
								//ShowHistoryMessage(urlComps);
								CString tmp = "";
								flags[IN_HISTORY] = 1;
								tmp.Format(_T(" You have already visited a page from '%s'. Therefore, SpoofGuard assumes that any page from this host is safe. To force SpoofGuard to recheck this page from this host, please clear your Internet Explorer history and restart Internet Explorer.\r\n"), urlComps.lpszHostName);
								warnings[IN_HISTORY] += tmp;
								outerFrameIsInHistory = 1;
								//UpdateStatus();

							} else {



								//the page is NOT in our history
								//firstalert - does first round checks
								//           - adds results, prints out warning string and send to UWToolBar
								//different from secondalert in that it does them INSIDE firstalert
								//secondalert just uses results from globals


								//Only try to stop navigation if there is a form in the site.


								


								if(FirstAlert(urlComps) && m_ReflectionWnd.GetToolBar().GetCheckedValue() /*&& isForm*/
									&& !alreadyWarned && !cancelledNavigation)
								{
									//the page is NOT in our history and the alert has been reached
									//okay, we're stopping the show.
									//ShowSpoofAlert(urlComps, Cancel);
									
									CString tmp = "";
									for(i=0;i<NUMBER_OF_TESTS - 1;i++)
										if(flags[i]){
											tmp += warnings[i];
										}

									CString warnMsg;
									warnMsg.Format(_T("The URL that you are about to load may be a spoof.\n\n%s\nDo you want to continue to this URL?\n\n Press 'Yes' to load the page from '%s'.\n Press 'No' to cancel the navigation if you believe that this may be a malicious redirection."),
										tmp, urlComps.lpszHostName);
									int choice = m_ReflectionWnd.MessageBox(warnMsg, _T("SpoofGuard"),
										MB_YESNO | MB_APPLMODAL | MB_ICONWARNING);

									alreadyWarned = 1;

									if(choice == IDNO) {
										//don't navigate...don't do anything
										*Cancel = TRUE;
										cancelledNavigation = 1;
									} /*else {
										//firstalert doesn't like this.
										//navigate anyway
										//ShowNoFirstMessage(urlComps);

										UpdateStatus();
									}*/
									

								}
								/*
								else
								{
									//the page is not in our history
									//but firstalert is okay
									//navigating anyway
									//ShowOKFirstMessage(urlComps);

									UpdateStatus();

								}*/
								/*
								if (!isOuterFrame)
								{
									//not in the outer frame
									//not in our history
									framesInHistory = 0;

									//add redirects to history -- we may not want to do this
									//if(m_pHistoryList)m_pHistoryList->AddHead(urlComps.lpszHostName);
								}
								*/
							}
						}
					}
				


				}

}

		}
		
		
		if(!cancelledNavigation) {
			UpdateStatus();
			m_ReflectionWnd.GetToolBar().ChangeHostName(urlComps.lpszHostName);
		}
	}

	//m_ReflectionWnd.MessageBox(_T("END-BEFORE NAVIGATE"), _T("SpoofGuard"), 0);
    return S_OK;
}

//this function checks the post data retrieved from BeforeNavigate2 function
void CWarnBar::PostDataCheck(VARIANT *PostData, VARIANT_BOOL *Cancel)
{
    if ((PostData != NULL) && PostData->vt == (VT_VARIANT|VT_BYREF) && PostData->pvarVal->vt != VT_EMPTY )
    {
        char *szTemp = NULL, *szPostData = NULL;
        long plLbound, plUbound;

        SAFEARRAY *parrTemp = PostData->pvarVal->parray;
        SafeArrayAccessData(parrTemp , (void HUGEP **) &szTemp);

        SafeArrayGetLBound(parrTemp , 1, &plLbound);
        SafeArrayGetUBound(parrTemp , 1, &plUbound);

        szPostData = new char[plUbound - plLbound + 2];
        StrCpyN(szPostData, szTemp, plUbound - plLbound + 1);
        szPostData[plUbound-plLbound] = '\0';
        SafeArrayUnaccessData(parrTemp);

        //m_ReflectionWnd.MessageBox(_T(szPostData), _T("Post Data"), 0);
        ScanPostData(szPostData, Cancel);
        delete[] szPostData;
    }
}

//called by PostDataCheck function
//creates a scanner, scans the postData,
//retrieves the username, password, and domain name from the data
void CWarnBar::ScanPostData(char *postData, VARIANT_BOOL *Cancel) {

    //what we look for in the username and domain name
    CString userStrings[USER] = {USER1, USER2, USER3, USER4, USER5, USER6, USER7, USER8, USER9, USER10, USER11, USER12, USER13, USER14, USER15, USER16, USER17, USER18, USER19, USER20};
    CString passStrings[PASS] = {PASS1, PASS2, PASS3, PASS4, PASS5, PASS6, PASS7, PASS8, PASS9, PASS10};

    CString token = postData;
    token.MakeLower();

    CString user = GetToken(token, userStrings, USER);
    CString pass = GetToken(token, passStrings, PASS);

    if (user.IsEmpty() || pass.IsEmpty() || m_ReflectionWnd.GetToolBar().GetCurrentDomain().IsEmpty()) return;

    //  m_ReflectionWnd.MessageBox(_T(token), _T("POST Data Token"), 0);
    //  m_ReflectionWnd.MessageBox(_T(user), _T("POST Data Username"), 0);
    //  m_ReflectionWnd.MessageBox(_T(pass), _T("POST Data Password"), 0);

    CheckPassword(user, pass, Cancel);
}

//this takes the token, and a list of ids
//the POST data's structure: userid=me&passwd=secret, etc.
//it finds whether userid or passwd, or any other words in the ids[]
//is in the token, and if so, it returns the value (ie me, secret, etc.)
CString CWarnBar::GetToken(const CString& token, const CString ids[], int len)
{
    int index = -1, index2 = -1;
    CString rightToken, retToken = "";

    for (int i = 0; i < len; i++) {
        index = token.Find(ids[i]);

        if(index != -1){

            //new index should be the character "="
            //e.g. login=myname, old index = 0, new index = 5
            index += ids[i].GetLength();

            if (token.GetAt(index) == '=') {
                //the id is set to equal something
                //move the index to the next word
                index++;
                index2 = token.GetLength() - index;
                rightToken = token.Right(index2);

                index2 = rightToken.Find('&');
                if (index2 == -1) {
                    //the retToken is at the end of the token
                    retToken = rightToken;
                    break;
                } else if (index2 == 0) {
                    //the retToken is empty
                    break;
                } else {
                    //the retToken is inthe middle of the token
                    retToken = rightToken.Left(index2);
                    break;
                }
            }
        }
    }
    return retToken;
}

//this function opens the password file
//the file design: domain name, username, password
//this function is only called if the above three
//information is available for this site
void CWarnBar::CheckPassword(const CString& user, const CString& password, VARIANT_BOOL *Cancel)
{
    FILE *fp = OpenPasswordFile();

    CString domainName = m_ReflectionWnd.GetToolBar().GetCurrentDomain();
    BOOL domainFound = false;

    CString names, oldToken = "", newLine = "";

    char* delimiters = WHITE_SPACE_DELIMITERS;
    char token[TOKEN_LEN];
    Scanner scan = NewScannerFromFile(fp, delimiters, true);

    CString pass = HashPassword(password);
    if (pass.IsEmpty()) return;


	domainFound = false;

    while (ReadNextToken(scan, token, TOKEN_LEN))
    {

		//m_ReflectionWnd.MessageBox(_T(token), _T("TOKENS"), 0);        

		if (domainName == token) {
            //the user has entered user/pass into this site
            //no problem

            if (ReadNextToken(scan, token, TOKEN_LEN)) {

                if (user == token) {
                    if (ReadNextToken(scan, token, TOKEN_LEN)) {
                        if (pass == token) {
                            //same username but different password
                            //record this new password
                            domainFound = true;
						}
                    }
                } else {
                    //different username
                    //do not overwrite since some ppl use different combo for the same site (eg hotmail)
                    //record this new username and password combination
                    //domainFound is false;
                }
            }

        } else if (user == token) {

            if (ReadNextToken(scan, token, TOKEN_LEN)) {

                if (pass == token) {
                    //user typed in the current user/pass pair
                    //into a different site before
                    //keep track of this domainname
                    names += " ";
                    names += oldToken;
                }
            } else {
                //pass not stored for this username
                //EOF reached
                FreeScanner(scan);
                return;
            }
        }
        oldToken = token;
    }

    FreeScanner(scan);
    if (domainFound) return;

    if (!names.IsEmpty()) {
        //same user/pass used before

        //m_ReflectionWnd.MessageBox(_T((CString) names), _T("Names not empty"), 0);

        names.TrimLeft();
        names.TrimRight();

        CString warnMsg;
        warnMsg = "The username and password that you entered match those of these sites: (" + names + "). You are about to submit this username and password to unrecognized host '" + domainName + "'.\n\nAre you sure you want to continue with this submission?";
        int choice = m_ReflectionWnd.MessageBox(warnMsg, _T("SpoofGuard"), MB_YESNO | MB_TASKMODAL | MB_ICONWARNING);

		alreadyWarned = 1;

        if(choice == IDNO) {
            //don't send the password information
            //BeforeNavigate2 gets this message and stops navigation.
            *Cancel = TRUE;
			cancelledNavigation = 1;
            return;
        }
    }

    //m_ReflectionWnd.MessageBox(_T("New line added"), _T("FILE Add"), 0);
    //just write domain, user, and password into the file
    fp = OpenPasswordFileAdd();
    if (!fp) return;
    if (domainName == "") domainName = DEFAULT_DOMAINNAME;
    newLine = domainName+" "+user+" "+pass;
    fputs(newLine, fp);
    fputc('\n', fp);
    fclose(fp);

}


//this function hashes the passwords
//called by Check Password

CString CWarnBar::HashPassword(const CString& pass)
{
    CSHA1 sha1;
    unsigned char token[20];
    unsigned char *password = (unsigned char *) const_cast <char*>((const char*) pass);

    sha1.Update(password, pass.GetLength());
    sha1.Final();
    sha1.GetHash(token);

    //  m_ReflectionWnd.MessageBox(_T((CString) token), _T("Hashed Password"), 0);

    return token;
}

//called by BeforeNavigate2 function
//the current status shown in the ToolBar is updated

void CWarnBar::UpdateStatus()
{
	
	

	/*
    m_ReflectionWnd.GetToolBar().ChangeHostName(_T(""));
    m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
    ChangeLight(preSum);
	*/
	
	if(flags[IN_HISTORY]){
		m_ReflectionWnd.GetToolBar().SetStatusMessage(warnings[IN_HISTORY]);
		ChangeLight(0);
		return;
	}
	
	int i = 0;
	CString tmp = "";
	//LED242 -- debug
	tmp.Format(_T("----TOTAL: %d----\r\n"),Total());
	int anyProblems = 0;

	for(i=0;i<NUMBER_OF_TESTS - 1;i++)
		if(flags[i]){
			anyProblems = 1;
			tmp += warnings[i];
		}

	if(!anyProblems) m_ReflectionWnd.GetToolBar().SetStatusMessage(_T("No problems detected with this site"));
	else m_ReflectionWnd.GetToolBar().SetStatusMessage(tmp);

	ChangeLight(Total());
}

//called by BeforeNavigate2 function
//called when the FirstAlert check level reached the threshold
//this function sets the Cancel boolean to true,
//and cancel navigation
/*
void CWarnBar::ShowSpoofAlert(URL_COMPONENTS &urlComps, VARIANT_BOOL *Cancel) {
    CString warnMsg;
    warnMsg.Format(_T("The URL that you are about to load may be a spoof.\n\n%s\nDo you want to continue to this URL?\n\n Press 'Yes' to load the page from '%s'.\n Press 'No' to cancel the navigation if you believe that this may be a malicious redirection."),
        totalErrorMessage, urlComps.lpszHostName);
    //int choice = m_ReflectionWnd.MessageBox(warnMsg, _T("SpoofGuard"),
        MB_YESNO | MB_APPLMODAL | MB_ICONWARNING);

    alreadyWarned = 1;

    if(choice == IDNO) {
        //don't navigate...don't do anything
        *Cancel = TRUE;
        cancelledNavigation = 1;
    } else {
        //firstalert doesn't like this.
        //navigate anyway
        //ShowNoFirstMessage(urlComps);
		
		//LED242 -- no longer needed
		//we always push the results
    }
}
*/

//called by BeforeNavigate2 function
//the site is not in the history, but the FirstAlert function
//shows that this site is probably not a spoofed site
//navigate anyway
/*
void CWarnBar::ShowOKFirstMessage(URL_COMPONENTS &urlComps) {

    m_ReflectionWnd.GetToolBar().ChangeHostName(urlComps.lpszHostName);
    m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
    ChangeLight(preSum);

    if(m_pHistoryList)
        m_pHistoryList->AddHead(urlComps.lpszHostName);
}
*/


//called by BeforeNavigate2 function
//the FirstAlert function shows that this site may be
//a spoofed site, but navigate anyway
/*
void CWarnBar::ShowNoFirstMessage(URL_COMPONENTS &urlComps) {
    m_ReflectionWnd.GetToolBar().ChangeHostName(urlComps.lpszHostName);
    m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
    ChangeLight(preSum);  //should be red

    if(m_pHistoryList)
        m_pHistoryList->AddHead(urlComps.lpszHostName);
}
*/

//called by BeforeNavigate2 function
//the current site is in the history list
//there is no problem with the site
/*
void CWarnBar::ShowHistoryMessage(URL_COMPONENTS &urlComps){
    isInHistory = 1;
    m_ReflectionWnd.GetToolBar().ChangeHostName(urlComps.lpszHostName);
    totalErrorMessage.Format(_T(" You have already visited a page from '%s'. Therefore, SpoofGuard assumes that any page from this host is safe. To force SpoofGuard to recheck this page from this host, please clear your Internet Explorer history and restart Internet Explorer.\r\n"), urlComps.lpszHostName);
    m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
    ChangeLight(0);
}
*/

//called by BeforeNavigate2 function
//we cannot retrieve the history list
//navigate anyway
/*
void CWarnBar::ShowNoHistoryMessage(URL_COMPONENTS &urlComps){
    isInHistory = 1;
    m_ReflectionWnd.GetToolBar().ChangeHostName(urlComps.lpszHostName);
    totalErrorMessage += _T(" SpoofGuard was unable to access your Internet Explorer history.\r\n");
    m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
    ChangeLight(0);
}
*/
// EnumerateHistory() is called only once for each instantiation of the WarnBar
// class. Enumerates through history and stores host names in a string list.

// Rewritten by Neil 08/06/2003. Fixed massive memory and logic errors.
// Simplified and optimized code.

void CWarnBar::EnumerateHistory()
{
    IEnumSTATURL *pEnumUrls;

    if ((m_pHistory == NULL) || (m_pHistoryList == NULL)
        || (m_pHistory->EnumUrls(&pEnumUrls) != S_OK))
    {
        return;
    }

    int maxToCount = m_ReflectionWnd.GetToolBar().GetHistValue();
    STATURL statUrl;
    ULONG ulFetched;

    while ((m_pHistoryList->GetCount() < maxToCount)
        && (pEnumUrls->Next(1, &statUrl, &ulFetched) == S_OK))
    {
        CHAR nonWideCharUrl[INTERNET_MAX_URL_LENGTH + 1];

        // Currently, this does not support Unicode. If UNICODE is defined,
        // then we need to skip the WideCharToMultiByte() call.
        WideCharToMultiByte(CP_ACP, 0, statUrl.pwcsUrl, -1, nonWideCharUrl,
            INTERNET_MAX_URL_LENGTH + 1, NULL, NULL);

        TCHAR canonicalizedURL[INTERNET_MAX_URL_LENGTH + 1];
        DWORD canonicalizedURLLength = INTERNET_MAX_URL_LENGTH;

        if (InternetCanonicalizeUrl(nonWideCharUrl,
            canonicalizedURL, &canonicalizedURLLength, 0))
        {
            URL_COMPONENTS urlComps;
            TCHAR hostName[INTERNET_MAX_HOST_NAME_LENGTH + 1];

            ZeroMemory(&urlComps, sizeof urlComps);
            urlComps.dwStructSize = sizeof urlComps;
            urlComps.lpszHostName = hostName;
            urlComps.dwHostNameLength = INTERNET_MAX_HOST_NAME_LENGTH;

            if (InternetCrackUrl(canonicalizedURL, canonicalizedURLLength, 0,
                &urlComps) && ((urlComps.nScheme == INTERNET_SCHEME_FTP)
                || (urlComps.nScheme == INTERNET_SCHEME_GOPHER)
                || (urlComps.nScheme == INTERNET_SCHEME_HTTP)
                || (urlComps.nScheme == INTERNET_SCHEME_HTTPS))
                && (m_pHistoryList->Find(hostName) == NULL))
            {
                // URL is cracked, it is of a protocol scheme we support, and
                // the host name is not already in the history list.
                m_pHistoryList->AddHead(hostName);
                TRACE("EnumerateHistory(): Added host name '%s'.\n", hostName);
            }
        }

        HeapFree(GetProcessHeap(), 0, statUrl.pwcsUrl);
        HeapFree(GetProcessHeap(), 0, statUrl.pwcsTitle);
    }

    SAFE_RELEASE(pEnumUrls);
}

//firstalert - does first round checks
//           - adds results, prints out warning string and send to UWToolBar
//different from secondalert in that it does them INSIDE firstalert
//secondalert just uses results from globals

int CWarnBar::FirstAlert(URL_COMPONENTS urlComps){

    //get total alert value
	/*
    int thresh = m_ReflectionWnd.GetToolBar().GetTotalAlertValue();
    preSum = 0;
	*/

    //do checks (set 1 so that they do string editing on totalErrorMessage)
    DomainCheck(urlComps, 1);
    URLCheck(urlComps, 1);

    //do checks
    EmailCheck(urlComps, 1);
	/*
    //no problem in the URL
    if(preSum == 0) {
        totalErrorMessage += _T(" SpoofGuard did not detect any problems in the URL of this page.\r\n\r\n");
    }

    //if we're over the totalalertvalue, return 1
    if(preSum >= thresh) {
        return 1;
    }
    return 0;
	*/

	return Thresh();
}

int CWarnBar::Thresh(){

	//LED242 -- new vars

	int thresh = m_ReflectionWnd.GetToolBar().GetTotalAlertValue();

	if(Total() >= thresh) return 1;
	return 0;
}

int CWarnBar::Total(){

	//LED242 -- new vars


	int total = 0;

	if(flags[TEST_DOMAIN]) total += m_ReflectionWnd.GetToolBar().GetDWeightValue();
	if(flags[TEST_URL]) total += m_ReflectionWnd.GetToolBar().GetUWeightValue();
	if(flags[TEST_EMAIL]) total += m_ReflectionWnd.GetToolBar().GetPWeightValue();
	
	if(flags[TEST_INPUT]) total += m_ReflectionWnd.GetToolBar().GetHWeightValue();
	if(flags[TEST_LINK]) total += m_ReflectionWnd.GetToolBar().GetLWeightValue();
	if(flags[TEST_IMAGE]) total += m_ReflectionWnd.GetToolBar().GetIWeightValue();
	if(flags[TEST_HTTPS]) total += m_ReflectionWnd.GetToolBar().GetXWeightValue();
	
	/*
	CString tmp1 = "";

	tmp1.Format(_T("--domain: %d \r\n-- URL: %d \r\n-- EMAIL: %d \r\n-- INPUT: %d \r\n-- LINK: %d \r\n-- IMAGE: %d \r\n-- HTTPS: %d")
		, m_ReflectionWnd.GetToolBar().GetDWeightValue()
		, m_ReflectionWnd.GetToolBar().GetUWeightValue()
		, m_ReflectionWnd.GetToolBar().GetPWeightValue()
		, m_ReflectionWnd.GetToolBar().GetHWeightValue()
		, m_ReflectionWnd.GetToolBar().GetLWeightValue()
		, m_ReflectionWnd.GetToolBar().GetIWeightValue()
		, m_ReflectionWnd.GetToolBar().GetXWeightValue()
		);
	//m_ReflectionWnd.MessageBox(tmp1, _T("SpoofGuard"), 0);
	*/
	return total;
}


//basically the same, but doesn't mess with globals, doesn't set strings
//this is used for link checking

int CWarnBar::FirstAlertClean(URL_COMPONENTS urlComps){

    if(!m_ReflectionWnd) return 0;
    if(!m_ReflectionWnd.GetToolBar()) return 0;

    int thresh = m_ReflectionWnd.GetToolBar()./*GetTotalAlertValue()*/ GetLSensitivityValue()  ;
    int pre = 0;

    if(DomainCheck(urlComps, 0)) {
			pre += m_ReflectionWnd.GetToolBar().GetDWeightValue();
			//m_ReflectionWnd.MessageBox(_T("DOMAIN"), _T("Link Check"), 0);
	}

    if(URLCheck(urlComps, 0)) {
		pre += m_ReflectionWnd.GetToolBar().GetUWeightValue();
		//m_ReflectionWnd.MessageBox(_T("URL"), _T("Link Check"), 0);
	}

    if(pre >= thresh) {
        return 1;
    }
    return 0;
}

//add results of second round checks
//print out warning string and send to UWToolBar
//pop up warning if necessary and requested
//this does not call the second round checks,
//just looks at results, stored in globals (repeatedimagefound, etc)

int CWarnBar::SecondAlert(IDispatch* pDisp, VARIANT* URL)
{
    int thresh = m_ReflectionWnd.GetToolBar().GetTotalAlertValue();
    int ret = 0;

	/*
    //reinit status message if necessary
    if(postSum == 0) {
        //m_ReflectionWnd.GetToolBar().SetStatusMessage(_T(""));
    }
	*/


    //set string if repeated image found
    //add weight to postSum
    if(repeatedImageFound) {
		/*
        totalErrorMessage += _T(" This page contains images that are identical to those on another Web site.\r\n");
        m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
        postSum += m_ReflectionWnd.GetToolBar().GetIWeightValue();
		*/
		flags[TEST_IMAGE] = 1;
		warnings[TEST_IMAGE] = _T(" This page contains images that are identical to those on another Web site.\r\n");
    }

    //set string if enough bad links found
    //add weight to postSum
    if(badLinkFound) {
		/*
        totalErrorMessage += _T(" This page contains possibly misleading links.\r\n");
        m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
        postSum += m_ReflectionWnd.GetToolBar().GetLWeightValue();
		*/
		flags[TEST_LINK] = 1;
		warnings[TEST_LINK] = _T(" This page contains possibly misleading links.\r\n");
    }

    //set string if password field found
    //add weight to postSum
    if(inputFieldsFound) {
		/*
        totalErrorMessage += _T(" This page contains password input fields. Make sure that you know and trust this site before submitting any personal information. Also ensure that this site supports encryption by checking for 'https://' in the Address bar.\r\n");
        m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
        postSum += m_ReflectionWnd.GetToolBar().GetHWeightValue();
		*/
		flags[TEST_INPUT] = 1;
		warnings[TEST_INPUT] = _T(" This page contains password input fields. Make sure that you know and trust this site before submitting any personal information. Also ensure that this site supports encryption by checking for 'https://' in the Address bar.\r\n");

        //If a password field is found in a non-HTTPS: site, we want to warn the user

        if (!encryptedSite) {
            /*
			totalErrorMessage += _T(" This site does not use encryption to protect your personal information upon submitting the form. Your password will be sent out in cleartext, which allows an attacker to capture it in transit. It is highly recommended that you do not continue unless this site does not have a secure page from which you can submit your information.\r\n");
            m_ReflectionWnd.GetToolBar().SetStatusMessage(totalErrorMessage);
            //maybe increment the postSum by one or two?
            
			//LED
			//postSum++;
			//postSum += m_ReflectionWnd.GetToolBar().GetPWeightValue();
			*/
			flags[TEST_HTTPS] = 1;
			warnings[TEST_HTTPS] = _T(" The password input fields on this page are not encrypted.\r\n");
        }
    }

	/*
    ret = (postSum >= thresh);

    //change the light on UWToolBar
    ChangeLight(postSum);

	//done in doc complete now
	*/



    return ret;
}


//Does the Domain Check
//prints to error message if problem found
int CWarnBar::DomainCheck(URL_COMPONENTS urlComps, int str){

    //this is the actual check
    CString hm = IsCloseMatch(urlComps.lpszHostName);

    if(hm.Compare("") != 0 && hm.CompareNoCase(urlComps.lpszHostName) != 0) {

        if(str){
            //problem found, print to error message
            
			CString tmp;
            tmp.Format(_T(" The requested host '%s' is similar in name to the host '%s'.\r\n"), urlComps.lpszHostName, hm);
            /*
			totalErrorMessage += tmp;
            preSum += m_ReflectionWnd.GetToolBar().GetDWeightValue();
			*/
			flags[TEST_DOMAIN] = 1;
			warnings[TEST_DOMAIN] = "";
			warnings[TEST_DOMAIN] += tmp;
        }

		//LED223
/*
		else {
			CString tmp;
            tmp.Format(_T(" The requested host '%s' is similar in name to the host '%s'.\r\n"), urlComps.lpszHostName, hm);
            //m_ReflectionWnd.MessageBox(_T(tmp), _T("DOMAIN"), 0); 
		}
*/

        return 1;
    }
    return 0;
}

//does the email link check
//At the moment, this is only called by FirstAlert, and not by First Alert Clean.
//It checks whether the current domain (referring site) is empty, and if so,
//there is a chance that the user is being referred to the site by email link,
//which is what spoof sites are linked from.

int CWarnBar::EmailCheck(URL_COMPONENTS urlComps, int str)
{
    CString domainName(m_ReflectionWnd.GetToolBar().GetCurrentDomain());

    if (domainName.IsEmpty())
    {
        //print to error message
		//totalErrorMessage += _T(" This Web page was opened in a new Internet Explorer window. Either you have opened a new window, or you may have clicked on an e-mail link from your e-mail program. Note that many deceptive and/or unsolicited e-mails contain links to Web sites that are actually spoofed sites.\r\n");
		flags[TEST_EMAIL] = 1;
		warnings[TEST_EMAIL] = _T(" This Web page was opened in a new Internet Explorer window. Either you have opened a new window, or you may have clicked on an e-mail link from your e-mail program. Note that many deceptive and/or unsolicited e-mails contain links to Web sites that are actually spoofed sites.\r\n");
	}
    else
    {
        static CStringList referrerList;
        static bool haveReadListFile = false;

        // Only read from the referrer list file once.
        if (!haveReadListFile)
        {
            char referrerLine[INTERNET_MAX_HOST_NAME_LENGTH + 1];
            FILE *fp = fopen(REFERRER_LIST_FILENAME, "rt");

            if (fp != NULL)
            {
                while (fgets(referrerLine, INTERNET_MAX_HOST_NAME_LENGTH + 1, fp) != NULL)
                {
                    CString newReferrerLine(referrerLine);
                    newReferrerLine.TrimLeft();
                    newReferrerLine.TrimRight();

                    if (!newReferrerLine.IsEmpty())
                    {
                        referrerList.AddTail(newReferrerLine);
                    }
                }

                fclose(fp);
                haveReadListFile = true;
            }
        }

        // Determine whether 'domainName' is actually an IP address, and if so,
        // resolve it to a host name, if possible.
        unsigned long properIPAddress = inet_addr(domainName);
        bool useHostName;

        if (properIPAddress != INADDR_NONE)
        {
            struct hostent *hostInfo = gethostbyaddr((char *) &properIPAddress, sizeof properIPAddress, AF_INET);
            if (hostInfo != NULL)
            {
                domainName = hostInfo->h_name;
                //                totalErrorMessage += _T(" Resolved. You are coming from '") + domainName + _T("'.\r\n");
                useHostName = true;
            }
            else
            {
                //                totalErrorMessage += _T(" I couldn't find where you were coming from.\r\n");
                useHostName = false;
            }
        }
        else
        {
            //            totalErrorMessage += _T(" You are coming from '") + domainName + _T("'.\r\n");
            useHostName = true;
        }

        if (useHostName)
        {
            for (POSITION iterReferrerList = referrerList.GetHeadPosition(); iterReferrerList != NULL; )
            {
                CString referrerString(referrerList.GetNext(iterReferrerList));
                int pos = domainName.Find(referrerString);
                
                // Checks to make sure 'referrerString' matches the right side of
                // 'domainName' and that 'referrerString' matches as a full host
                // name (so that 'mail.com' does not fit into 'hotmail.com').

                if ((pos != -1) && (domainName.GetLength() - referrerString.GetLength() == pos)
                    && ((pos == 0) ? true : (domainName.GetAt(pos - 1) == '.')))
                {

                    CString tmp;
                    tmp.Format(_T(" You may have clicked on an e-mail link. You are coming from host '%s', which SpoofGuard recognizes as a Web e-mail provider (listed in your Referrer List as '%s'). Note that many deceptive and/or unsolicited e-mails contain links to Web sites that are actually spoofed sites.\r\n"), domainName, referrerString);
                    //totalErrorMessage += tmp;
					flags[TEST_EMAIL] = 1;
					warnings[TEST_EMAIL] = ""+tmp;
                    break;

                }
            }
        }
    }

    // This should probably be user-adjustable through the UI.
	//LED242
    //preSum++;
    return 0;
}


//does the url check
int CWarnBar::URLCheck(URL_COMPONENTS urlComps, int str){

    //what we look for in the username and domain name
    CString domainSubstrings[SUBS] = {SUB1,SUB2,SUB3,SUB4,SUB5,SUB6,SUB7,SUB8,SUB9,SUB10,SUB11,SUB12};

    CString uName = urlComps.lpszUserName;
    CString hName = urlComps.lpszHostName;

    uName.MakeLower();
    hName.MakeLower();

	CString totalErrorMessage = "";

    int i;
    int ret = 0;
    int ret2 = 0;
    int ret3 = 0;

    //check1
    if(uName.CompareNoCase("")) {
        for (i = 0; i < SUBS; i++) {
            if( uName.Find(domainSubstrings[i]) != -1 ){
                //suspicious username

                if(str){

                    CString tmp;
                    tmp.Format(_T(" The user name '%s' may be disguised to look like a host name.\r\n"), uName);
                    totalErrorMessage += tmp;
                }
                ret = 1;
                break;
            }
        }

        //check2

        ret2 = 1;  //must have username to have a hidden domain

        for (i = 0; i < SUBS; i++) {

            if( hName.Find(domainSubstrings[i]) != -1 ){
                ret2 = 0;
                break;
            }
        }
    }

    if(ret2 && str){
        CString tmp;
        tmp.Format(_T(" The host name '%s' may be hidden.\r\n"), hName);
        totalErrorMessage += tmp;
    }

    //check3
	
    INTERNET_PORT nport = urlComps.nPort;

	/*
    //check port number HTTPS_PORT
    //change encryptedSite to 1 if it is an encrypted site

    if (str && nport == INTERNET_DEFAULT_HTTPS_PORT) {
        encryptedSite = 1;
    }
	*/

    //check port numbers

    if(!(nport == INTERNET_DEFAULT_FTP_PORT     ||
        nport == INTERNET_DEFAULT_GOPHER_PORT   ||
        nport == INTERNET_DEFAULT_HTTP_PORT    ||
        nport == INTERNET_DEFAULT_HTTPS_PORT    ||
        nport == INTERNET_DEFAULT_SOCKS_PORT)    ) ret3 = 1;

    if(ret3 && str){
        CString tmp;
        tmp.Format(_T(" This page was loaded from the host from port %d. This port is not standard for use on the Web.\r\n"), nport);
        totalErrorMessage += tmp;
    }

    //if we have any problems, activate this check

    int res = (ret||ret2||ret3);
    if(res && str) {
        //preSum += m_ReflectionWnd.GetToolBar().GetUWeightValue();
		flags[TEST_URL] = 1;
		warnings[TEST_URL] = "" + totalErrorMessage;
    }

    return res;
}

// Does a linear search through our history list for the closest match
// that is less than the sensitivity of this check

CString CWarnBar::IsCloseMatch(const char *hostName)
{
    int threshold = m_ReflectionWnd.GetToolBar().GetDistValue();
    CString currClosest;
    CString currString;
    int minDist = 9999;
    int currDist;

    if(!m_pHistoryList) return currClosest;

    int numItems = m_pHistoryList->GetCount();
    if(m_pHistoryList && numItems > 0) {

        POSITION pos = m_pHistoryList->GetHeadPosition();

        //iterate history
        for(int i=0; i < numItems; i++) {
            currString = m_pHistoryList->GetAt(pos);

            //calculate the Edit Distance to each domain in our history
            currDist = LevenshteinDistance(hostName, (LPCSTR)currString);
            if(currDist <= threshold && currDist < minDist) {
                minDist = currDist;
                currClosest = currString;
            }

            currString = m_pHistoryList->GetNext(pos);
        }
    }

    return currClosest;
}

// Based on Levenshtein algorithm as described at http://www.merriampark.com/ld.htm
// Also known as the "Edit Distance"

int CWarnBar::LevenshteinDistance(const char* cStr1, const char* cStr2) {

    if(!cStr1 || !cStr2)
        return -1;

    const int MAX_PATH_LEN = 260; // Max is really 253
    char str1[MAX_PATH_LEN];
    char str2[MAX_PATH_LEN];
    strncpy(str1, cStr1, MAX_PATH_LEN-1);
    strncpy(str2, cStr2, MAX_PATH_LEN-1);

    int i, j, n, m, cost, above, left, diagonal;

    n = strlen(str1);
    m = strlen(str2);
    if(n==0)
        return m;
    if(m==0)
        return n;

    // Declare array this way to avoid taking up too much space on the stack
    int *matrix[MAX_PATH_LEN];
    for(i=0; i<=n; i++)
        matrix[i] = (int*)malloc(sizeof(int) * (m+1));

    for(i=0; i <= n; i++)
        matrix[i][0] = i;
    for(i=0; i <= m; i++)
        matrix[0][i] = i;

    for(i=1; i <= n; i++) {
        for(j=1; j <= m; j++) {
            cost = ((tolower(str1[i-1]) == tolower(str2[j-1])) ? 0 : 1);
            above = matrix[i][j-1] + 1;
            left = matrix[i-1][j] + 1;
            diagonal = matrix[i-1][j-1] + cost;
            if(above <= left) {
                matrix[i][j] = ((above < diagonal) ? above : diagonal);
            }
            else {
                matrix[i][j] = ((left < diagonal) ? left : diagonal);
            }
        }
    }

    int res = matrix[n][m];
    for(i=0; i<=n; i++)
        free(matrix[i]);

    return res;
}

//Implemented for IObjectWithSite
STDMETHODIMP CWarnBar::GetSite(REFIID riid, void **ppvSite)
{

    *ppvSite = NULL;

    if(m_pSite)
    {
        return m_pSite->QueryInterface(riid, ppvSite);
    }
    return E_FAIL;
}


// Implemented for IPersist
STDMETHODIMP CWarnBar::GetClassID(CLSID *pClassID)
{
    *pClassID = CLSID_WarnBar;
    return S_OK;
}


// Implemented for IPersistStream
STDMETHODIMP CWarnBar::IsDirty(void)
{
    TRACE("*****ISDIRTY*****\n");
    return S_FALSE;
}

// Implemented for IPersistStream
STDMETHODIMP CWarnBar::Load(IStream *pStm)
{
    TRACE("*****LOAD****\n");
    return S_OK;
}

// Implemented for IPersistStream
STDMETHODIMP CWarnBar::Save(IStream *pStm, BOOL fClearDirty)
{
    TRACE("******SAVE*****\n");
    return S_OK;
}

// Implemented for IPersistStream
STDMETHODIMP CWarnBar::GetSizeMax(ULARGE_INTEGER *pcbSize)
{
    return E_NOTIMPL;
}
