//WarnBar.h : Declaration of the CWarnBar

#ifndef __WARNBAR_H_
#define __WARNBAR_H_

#include "resource.h"       // main symbols
#include "ReflectionWnd.h"  // To channel messages through to UWToolBar

// These are needed for IDeskBand
#include <shlguid.h>
#include <shlobj.h>
#include <mshtml.h>
#include <wchar.h>
// For IDispEvent Sinkhole
#include <exdispid.h>

#include <sys/timeb.h>
#include <time.h>

//#include <ExDisp.h>
//#include <mshtml.h>
//#pragma warning(disable : 4192) // multiple defines on typical ifaces, okay to
//#pragma warning(disable : 4049) // MSHTML is a *big* TLB
//#pragma warning(disable : 4146) // unary minus operator in TLB, doesn't always ignore though
//#import "c:\winnt\system32\mshtml.tlb" raw_interfaces_only, raw_native_types, named_guids
//#import "c:\winnt\system32\shdocvw.dll" exclude("tagREADYSTATE") raw_interfaces_only, raw_native_types, named_guids

//URL Check Subs
#define SUBS  12

#define SUB1  _T(".com")
#define SUB2  _T(".net")
#define SUB3  _T(".org")
#define SUB4  _T(".us")
#define SUB5  _T(".biz")
#define SUB6  _T(".info")
#define SUB7  _T(".tv")
#define SUB8  _T(".ws")
#define SUB9  _T(".cc")
#define SUB10 _T(".edu")
#define SUB11 _T("http")
#define SUB12 _T("www.")

//Username Check Defs
#define USER 20

#define USER1 _T("login")
#define USER2 _T("user")
#define USER3 _T("username")
#define USER4 _T("screenname")
#define USER5 _T("userid")
#define USER6 _T("usr_name")
#define USER7 _T("user_name")
#define USER8 _T("screen_name")
#define USER9 _T("customer")
#define USER10 _T("cust")
#define USER11 _T("loginname")
#define USER12 _T("custid")
#define USER13 _T("accessid")
#define USER14 _T("access_id")
#define USER15 _T("loginid")
#define USER16 _T("login_id")
#define USER17 _T("user_id")
#define USER18 _T("login_name")
//the last two are not "usernames"
//but some sites use email instead of login names
//if none of USER1-USER18 is found, check for email
#define USER19 _T("login_email")
#define USER20 _T("email")

//Password Check Defs
#define PASS 10

#define PASS1 _T("password")
#define PASS2 _T("passcode")
#define PASS3 _T("passwd")
#define PASS4 _T("pass")
#define PASS5 _T("user_password")
#define PASS6 _T("usr_password")
#define PASS7 _T("login_password")
#define PASS8 _T("login_passcode")
#define PASS9 _T("login_passwd")
#define PASS10 _T("login_pass")

#define PASSWD_FILENAME _T("..\\SpoofPass.txt")

//For Scanner
#define WHITE_SPACE_DELIMITERS " \t\n "
#define TOKEN_LEN 128

#define DEFAULT_DOMAINNAME "DOMAIN"

#define IMAGE_FILENAME _T("..\\SpoofImg.bin")
#define REFERRER_LIST_FILENAME _T("..\\SpoofWatchReferrerList.txt")
#define MAX_IMAGE_HASHES 1023

#define IMG_MINWIDTH  25
#define IMG_MAXWIDTH  700
#define IMG_MINHEIGHT 25
#define IMG_MAXHEIGHT 700
#define IMG_MINSIZE   64
#define IMG_MAXSIZE   75 * 1024

#define SAFE_RELEASE(x) {x->Release(); x = NULL;}


#define TEST_DOMAIN 0
#define TEST_URL 1
#define TEST_EMAIL 2

#define TEST_LINK 3
#define TEST_IMAGE 4
#define TEST_INPUT 5
#define TEST_HTTPS 6

#define AVAILABLE_HISTORY 7
#define AVAILABLE_URL 8

#define IN_HISTORY 9

#define NUMBER_OF_TESTS 10
#define NUMBER_OF_WARNINGS 10

#define TESTING_PREFIX _T("http://crypto.stanford.edu/SpoofGuard/BEWARE_FAKE_SITE/")
#define TESTING_INDEX 55

//#define TESTING_PREFIX _T("http://www.stanford.edu/~led242/")
//#define TESTING_INDEX 32


/////////////////////////////////////////////////////////////////////////////
// CWarnBar
class ATL_NO_VTABLE CWarnBar :
public CComObjectRootEx<CComSingleThreadModel>,
public CComCoClass<CWarnBar, &CLSID_WarnBar>,
public IDeskBand,
public IObjectWithSite,
public IPersistStream,
public IDispatchImpl<IWarnBar, &IID_IWarnBar, &LIBID_URLWARNINGLib>,
public IDispEventImpl<0, CWarnBar, &__uuidof(/*SHDocVw::*/DWebBrowserEvents2), &LIBID_SHDocVw, 1, 0>
{
    typedef IDispEventImpl<0, CWarnBar, &__uuidof(/*SHDocVw::*/DWebBrowserEvents2), &LIBID_SHDocVw, 1, 0> theDispEvent;

public:
    CWarnBar();

    DECLARE_REGISTRY_RESOURCEID(IDR_WARNBAR)

        DECLARE_PROTECT_FINAL_CONSTRUCT()

        BEGIN_CATEGORY_MAP(CWarnBar)
        //  IMPLEMENTED_CATEGORY(CATID_InfoBand)
        //  IMPLEMENTED_CATEGORY(CATID_CommBand)
        //  IMPLEMENTED_CATEGORY(CATID_DeskBand)
        END_CATEGORY_MAP()


        //COM interfaces supported
        //we mainly care about IObjectWithSite

        BEGIN_COM_MAP(CWarnBar)
        COM_INTERFACE_ENTRY(IWarnBar)
        COM_INTERFACE_ENTRY(IOleWindow)
        COM_INTERFACE_ENTRY_IID(IID_IDockingWindow, IDockingWindow)
        COM_INTERFACE_ENTRY(IObjectWithSite)
        COM_INTERFACE_ENTRY_IID(IID_IDeskBand, IDeskBand)
        COM_INTERFACE_ENTRY(IPersist)
        COM_INTERFACE_ENTRY(IPersistStream)
        COM_INTERFACE_ENTRY(IDispatch)
        END_COM_MAP()


        //this registers our event sinks (beforenavigate, documentcomplete)
        //that allow us to get useful information from the browser


        BEGIN_SINK_MAP(CWarnBar)
        //SINK_ENTRY(0, (__uuidof(DWebBrowserEvents2)), BeforeNavigate2);
        SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)), DISPID_BEFORENAVIGATE2, BeforeNavigate2)

        SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)), DISPID_DOCUMENTCOMPLETE, DocumentComplete)

        //  SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)), DISPID_NEWWINDOW2, NewWindow2)

        //DISPID_NEWWINDOW2
        //SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)), DISPID_NAVIGATECOMPLETE2, NavigateComplete2)

        //SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)), 0x000000fc, NavigateComplete2)
        END_SINK_MAP()


        //these are the methods that our interfaces must implement

        // DWebBrowserEvents2
public:
    HRESULT __stdcall DocumentComplete(IDispatch* pDisp, VARIANT* URL);
    //HRESULT __stdcall NavigateComplete2(IDispatch* pDisp, VARIANT* URL);  /
    HRESULT __stdcall BeforeNavigate2(IDispatch *pDisp, VARIANT *URL, VARIANT *Flags,
        VARIANT *TargetFrameName, VARIANT *PostData,
        VARIANT *Headers, VARIANT_BOOL *Cancel);

    //  HRESULT __stdcall NewWindow2(IDispatch** &ppDisp,VARIANT_BOOL* &Cancel);

    // IDeskBand
public:
    STDMETHOD(GetBandInfo)(DWORD dwBandID, DWORD dwViewMode, DESKBANDINFO* pdbi);

    // IObjectWithSite
public:
    STDMETHOD(SetSite)(IUnknown* pUnkSite);
    STDMETHOD(GetSite)(REFIID riid, void **ppvSite);

    // IOleWindow
public:
    STDMETHOD(GetWindow)(HWND* phwnd);
    STDMETHOD(ContextSensitiveHelp)(BOOL fEnterMode);

    // IDockingWindow
public:
    STDMETHOD(CloseDW)(DWORD dwReserved);
    STDMETHOD(ResizeBorderDW)(LPCRECT prcBorder, IUnknown *punkToolbarSite, BOOL fReserved);
    STDMETHOD(ShowDW)(BOOL fShow);

    // IPersist
public:
    STDMETHOD(GetClassID)(CLSID *pClassID);

    // IPersistStream
public:
    STDMETHOD(IsDirty)(void);
    STDMETHOD(Load)(IStream *pStm);
    STDMETHOD(Save)(IStream *pStm, BOOL fClearDirty);
    STDMETHOD(GetSizeMax)(ULARGE_INTEGER *pcbSize);

	//LED242
	STDMETHOD(SendEmail)(int isBefore);

    // IWarnBar
protected:
    //helper
    BOOL RegisterAndCreateWindow();

protected:

    DWORD m_dwBandID;
    DWORD m_dwViewMode;
    BOOL m_bShow;
    BOOL m_bEnterHelpMode;
    HWND m_hWndParent;

    //HWND m_hWnd;
    //our reflection window
    CReflectionWnd      m_ReflectionWnd;
    IInputObjectSite*   m_pSite;

    //our history
    IUrlHistoryStg*     m_pHistory;

    //our list of history entries
    CStringList*        m_pHistoryList;

    IWebBrowser2*       m_webBrowser;

    //temporary variables to store values from the registry
    BOOL                            m_LoadedFromReg;
    int                             m_RegHist;
    int                             m_RegDist;
    BOOL                            m_RegWarn;
    BOOL                            m_RegWarnI;
    BOOL                            m_RegWarnL;

    int                             m_RegDWeight;
    int                             m_RegUWeight;
    int                             m_RegHWeight;
    int                             m_RegLWeight;
    int                             m_RegIWeight;
    int                             m_RegTotalAlert;

	//LED
	int								m_RegLSensitivity;
	int								m_RegPWeight;
	int								m_RegXWeight;

    //control variables to keep track of the state of our warnings
    //int                             preSum;
    //int                             postSum;
	int								flags[NUMBER_OF_TESTS];
	CString							warnings[NUMBER_OF_WARNINGS];

    int                             alreadyWarned;
    int                             outerFrameIsInHistory;
    int                             repeatedImageFound;
    int                             badLinkFound;
    int                             inputFieldsFound;

//    int                             beforeNaved;
    int                             registered;
	CString							outerDomain;

//    int                             redirect;
//    int                             framesInHistory;

    int                             cancelledNavigation;

    int                             encryptedSite;

    int                             isForm;
    int                             isSubmit;

	
	//for performance checks
	struct _timeb timebuffer1;
	struct _timeb timebuffer2;

    //int                               isTopFrame;
    //int                               depth;

    /*
    int                             m_D;
    CString                         m_DStr;
    int                             m_U;
    CString                         m_UStr;
    int                             m_H;
    CString                         m_HStr;
    */
    //CString                         totalErrorMessage;

    /*
    CString                         m_CompositeErrorMessage;
    CString                         m_CurrentCompositeErrorMessage;
    */

    //CString                           domainSubstrings[SUBS];

    // IDispatch Object
    //IDispatch* m_pDisp;
public:
    //  IUnknown* globalpUnkSite;


    // Helper functions
protected:
    int LevenshteinDistance(const char* cStr1, const char* cStr2);
    void EnumerateHistory();
    CString IsCloseMatch(const char *hostName);
    void LoadRegVals();
    void SaveRegVals();

    int FirstAlert(URL_COMPONENTS urlComps);
    int FirstAlertClean(URL_COMPONENTS urlComps);
    int SecondAlert(IDispatch* pDisp, VARIANT* URL);
    int DomainCheck(URL_COMPONENTS urlComps, int str);

    int EmailCheck(URL_COMPONENTS urlComps, int str);
    int HTMLCheckPasswords(IDispatch &myDispatch2);
    void HTMLCheckButtons(IDispatch &myDispatch2);

    int URLCheck(URL_COMPONENTS urlComps, int str);
    int HTMLCheckInput(IHTMLDocument2 *doc, VARIANT* URL);
    int HTMLCheckLinks(IHTMLDocument2 *doc, VARIANT* URL);
    void ChangeLight(int sum);

    int ImageCheck(IHTMLDocument2 *doc, VARIANT* URL);
    unsigned int BstrToInt(BSTR bstr);
    int ReadImageIntoBuffer(const CString& imageURL, BYTE *imageBuffer, unsigned int imageSize);
    PBYTE HashBuffer(BYTE *imageBuffer, unsigned int imageSize, DWORD *hashLength);
    int IterateHashFile(BYTE *hashArray[], unsigned int numHashes, unsigned int hashLength, unsigned int domainLength);
    int FileExists();
    int GetDocument(IDispatch* pDisp, IHTMLDocument2 **returnDoc);
    int GetDocument3(IDispatch* pDisp, IHTMLDocument3 **returnDoc);
    void PostDataCheck(VARIANT *PostData, VARIANT_BOOL *Cancel);
    //void ShowHistoryMessage(URL_COMPONENTS &urlComps);
    //void ShowNoHistoryMessage(URL_COMPONENTS &urlComps);
    //void ShowOKFirstMessage(URL_COMPONENTS &urlComps);
    //void ShowNoFirstMessage(URL_COMPONENTS &urlComps);
    //void ShowSpoofAlert(URL_COMPONENTS &urlComps, VARIANT_BOOL *Cancel);
    void UpdateStatus();
    void ScanPostData(char *postData, VARIANT_BOOL *Cancel);
    CString GetToken(const CString& token, const CString ids[], int len);
    FILE* OpenPasswordFile();
    void CheckPassword(const CString& user, const CString& password, VARIANT_BOOL *Cancel);
    FILE* OpenPasswordFileAdd();
    CString HashPassword(const CString& pass);

	int Thresh();
	int Total();
};

#endif //__WARNBAR_H_
